function readMore()
service.getText(node)
require "import"
import "android.app.*"
import "com.androlua.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "java.io.*"
import "java.util.*"
import "android.content.*"

local l = Locale.getDefault().getLanguage()

local title, btn, btn2, btn3

if l == "ar" then
  title = " قراءة المزيد  "
  btn = " غلق النافذة "
  btn2 = " نسخ النص الى الحافظة"
  btn3 = " مشاركة النص"
elseif l == "en" then
  title = " the full text"
  btn = " Close "
  btn2 = " Copy to clipboard "
  btn3 = " share the text "
elseif l == "fr" then
  title = " Le text entier "
  btn = " Quiter "
  btn2 = " Copier le text "
  btn3 = " Partager le text "
end

local applicationName = node.getPackageName()
local appName = {"com.whatsapp", 'com.whatsapp.w4b', 'com.gbwhatsapp'}
local text2 = {"‏قراءة المزيد|Voir plus|Read more"}

for i = 1, #appName do
  if applicationName == appName[i] and this.findAccessibilityNodeInfo(text2[1]) then

    service.click({
      {"‏قراءة المزيد|Voir plus|Read more$0<500>50", }
    })

    task(1, function()
      local text = {service.getText(node)}

      local layout = {
        LinearLayout,
        orientation = "vertical",
        layout_width = "match_parent",
        layout_height = "wrap_content",
        padding = "16dp",
        {
          ListView,
          id = "ls",
          layout_width = "match_parent",
          layout_height = "wrap_content",
        },
      }

      dlg = LuaDialog(this)
      dlg.setTitle(title)
      dlg.View = loadlayout(layout)

      -- عرض النص كسطور داخل ListView
      ls.adapter = ArrayListAdapter(this, String(text[1]).split("\n"))

      dlg.Button = btn

      dlg.setButton2(btn2, function()
        this.copy(text[1])
      end)

      dlg.setButton3(btn3, function()
        local i = Intent(Intent.ACTION_SEND)
          .setType("text/plain")
          .putExtra(Intent.EXTRA_TEXT, text[1])
        this.startActivity(i)
      end)

      dlg.show()
    end)
  end
end

end
if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          if text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "جي بي تي" then
            dofile(dir.. "ChatGPT.lua")
            return
           elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "الاوامر الرئيسيه" then
            dofile(dir.. "MainVoiceCommands.lua")
            return
           elseif text:lower() == "مساعد الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"<#com.google.android.googlequicksearchbox:id/assistant_robin_floaty_single_line_query>20$1500","%dictAr",}})
            return
           elseif text:lower() == "وصف الشاشه" or text:lower() == "مساعد شاشه الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"#com.google.android.googlequicksearchbox:id/assistant_robin_screen_context_default_chip>20$1500","%Retour$1000","%dictAr",}})
            return
           elseif text == "الاملاء بالعربيه" then
            dictAr()
            return
         elseif text:lower() == "الباحث القراني" or text:lower() == "البحث في القران" then
          dofile(dir.. "searchQuran.lua")
          return



           elseif text == "حذف البيانات" then
            local applicationName = node.getPackageName()
            if applicationName == "com.whatsapp.w4b" then
              require 'import' import "android.content.*" i= Intent() .setComponent(ComponentName("com.whatsapp.w4b", "com.whatsapp.settings.ui.SettingsDataUsageActivity")) this.startActivity(i)
              service.click({{"#setting_storage_usage>10$100","#large_files_container>10$100","#media_select_all_checkbox>10$100","Supprimer|‏حذف>10","#button1", "%Retour<3",}})
             elseif applicationName == "com.whatsapp" then
              require 'import' import "android.content.*" i= Intent() .setComponent(ComponentName("com.whatsapp", "com.whatsapp.settings.SettingsDataUsageActivity")) this.startActivity(i)
              service.click({{"#setting_storage_usage>10$100","#large_files_container>10$100","#media_select_all_checkbox>10$100","Supprimer|‏حذف>10","#button1", "%Retour<3",}})
            end
            return
           elseif text == "حذف المحادثه" then
            service.click({{"%pression prolongée$400","#menuitem_conversations_delete>4$200","<#delete_media_container$100","%未选择$300","#button1",}})
            return
           elseif text == "التحكم في المجموعه" then

            service.click({{"%clique direct$100", "#info_btn>10$100","#menuitem_overflow>10$100","‏أذونات المجموعة|Autorisations du groupe>10$100","#send_messages_switch>10$100", "%Retour<4$500",}})
            return
           elseif text == "حاله جديده" then
            service.click({{"‏حالة جديدة|Nouvelle mise à jour de statut",}})
            return
           elseif text == "حاله كتابيه جديده" or text == "حاله النصيه جديده" then
            service.click({{"‏التحديثات|Actus$100", "‏حالة كتابية جديدة|Nouveau message de statut>10",}})
            task(1600, function() dictAr() end)
            return
           elseif text == "المكالمه الاخيره" then
            service.click({{"‏المكالمات|Appels$300","<#call_row_container#1>4",}})
            return

           elseif text == "الاتصال بالمكالمه الاخيره" then
            service.click({{"‏المكالمات|Appels$300","‏مكالمة جديدة|Nouvel appel>4$200", "#row_container#1>4$300","#selected_list_action_fab_1>4", }})
            return

           elseif text == "تبديل الحساب" or text == "تغيير الحسابا" then
            service.click({{"#menuitem_overflow>4$10","‏تبديل الحسابات|Changer de compte>5",}})
            return
           elseif text == "البحث" then
            service.click({"#my_search_bar", "#menuitem_search", "#action_search_chat",})
            task(1600, function() dictAr() end)
            return
           elseif text == "قراءه الكل" or text == "تمت قراءه الكل" then
            service.click({{"#menuitem_overflow$100","‏قراءة الكل|Tout lire",}})
            return
           elseif text == "الرسائل المفضله" or text == "الرسائل المميزه" then
            service.click({{"#menuitem_overflow$100","‏الرسائل المميزة بنجمة|Messages importants",}})
            return
           elseif text == "الرسائل غير المقروءه" then
            service.click({{"%clique direct$1300","#unread_divider_tv",}})
            return
           elseif text == "قراءه المزيد" then
service.click({{"%Retour$300", "%readMore",
}})            return
           elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then
            local helpText = [[
توقف
تحديث المفتاح
المساعد السريع
مساعد الهاتف
وصف الشاشة، أو مساعد شاشة الهاتف
جي بي تي 
الأوامر الرئيسية
الإملاء بالعربية
الباحث القرآني أو البحث في القرآن
حذف البيانات  
حذف  المحادثة
الرسائل غير المقروءة
قراءة المزيد
لتشغيل هذا الأمر يجب أن نضغط على الرسالة التي تحتوي على "قراءة المزيد" ضغطتين، والثانية مطولة، ثم بعد ذلك نتلمسها مجدداً، ثم بعد ذلك ننفذ الأمر.
التحكم في المجموعة  
لتفعيل الأمر السابق، يرجى الوقوف على الصورة الخاصة بالمجموعة من الشاشة الرئيسية للتطبيق.
حالة جديدة  
حالة كتابية جديدة,  أو حالة نصية جديدة  
المكالمة الأخيرة  
الاتصال بالمكالمة الأخيرة  
البحث  
قراءة الكل،  أو تمت قراءة الكل  
الرسائل المفضلة  أو الرسائل المميزة  
تغيير الحساب أو تبديل الحساب
المساعدة
المساعَدة العامة.
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return
           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("WhatsApp")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end