dir = package.searchpath("main", package.path):match("(.*)main.lua")
dir2=package.searchpath("main",package.path):match("(.*)main.lua").."Applications/"
dir3=package.searchpath("main",package.path):match("(.*)main.lua").."launcher/"


if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          if text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "جي بي تي" then
            dofile(dir.. "ChatGPT.lua")
            return
           elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "الاوامر الرئيسيه" then
            dofile(dir.. "MainVoiceCommands.lua")
            return
           elseif text:lower() == "مساعد الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"<#com.google.android.googlequicksearchbox:id/assistant_robin_floaty_single_line_query>20$1500","%dictAr",}})
            return
           elseif text:lower() == "وصف الشاشه" or text:lower() == "مساعد شاشه الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"#com.google.android.googlequicksearchbox:id/assistant_robin_screen_context_default_chip>20$1500","%Retour$1000","%dictAr",}})
            return
           elseif text == "الاملاء بالعربيه" then
            dictAr()
            return
         elseif text:lower() == "الباحث القراني" or text:lower() == "البحث في القران" then
          dofile(dir.. "searchQuran.lua")
          return


           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return

           elseif text == "" then
            service.click({{}})
            return

           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then

            local helpText = [[
توقف
تحديث المفتاح
المساعد السريع
مساعد الهاتف
وصف الشاشة، أو مساعد شاشة الهاتف
جي بي تي 
الأوامر الرئيسية
الإملاء بالعربية
الباحث القرآني أو البحث في القرآن
المساعدة
المساعَدة العامة.
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return
           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("تطبيق ")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end