require "import"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "com.androlua.LuaDialog"
import "android.content.Intent"
import "android.R"
import "android.view.View"
import "android.widget.AdapterView"
import "android.widget.ArrayAdapter"
import "android.widget.Button"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "android.widget.ListView"
import "android.widget.TextView"
import "com.androlua.LuaDialog"


layout={
  LinearLayout,
  layout_width="match_parent",
  layout_height="match_parent",
  orientation=1,

  {
    LinearLayout,
    orientation=0,
    layout_width="match_parent",

    {
      TextView,
      id = "textview",
      text = "أدواتُ التعديل",
onClick=function()
function is_numeric_arabic(codepoint)
    local numeric_arabic = {
        [0x0660] = true, -- ٠
        [0x0661] = true, -- ١
        [0x0662] = true, -- ٢
        [0x0663] = true, -- ٣
        [0x0664] = true, -- ٤
        [0x0665] = true, -- ٥
        [0x0666] = true, -- ٦
        [0x0667] = true, -- ٧
        [0x0668] = true, -- ٨
        [0x0669] = true, -- ٩
    }
    return numeric_arabic[codepoint]
end

function count_characters(text)
    local count = 0
    for _, codepoint in utf8.codes(text) do
        if ((codepoint >= 0x0041 and codepoint <= 0x005A) or -- A-Z
            (codepoint >= 0x0061 and codepoint <= 0x007A) or -- a-z
            (codepoint >= 0x00C0 and codepoint <= 0x00FF) or -- Latin-1 Supplement
            (codepoint >= 0x0600 and codepoint <= 0x06FF and not is_numeric_arabic(codepoint))) then -- Arabic
            if not (codepoint == 0x060C or -- ،
                    codepoint == 0x061F or -- ؟
                    codepoint == 0x061B) then -- ؛
                count = count + 1
            end
        end
    end
    return count
end

function count_arabic_characters(text)
    local count = 0
    for _, codepoint in utf8.codes(text) do
        if (codepoint >= 0x0600 and codepoint <= 0x06FF and not is_numeric_arabic(codepoint)) then -- Arabic
            if not (codepoint == 0x060C or -- ،
                    codepoint == 0x061F or -- ؟
                    codepoint == 0x061B) then -- ؛
                count = count + 1
            end
        end
    end
    return count
end


function count_latin_characters(text)
    local count = 0

    for _, codepoint in utf8.codes(text) do
        if ((codepoint >= 0x0041 and codepoint <= 0x005A) or -- A-Z
            (codepoint >= 0x0061 and codepoint <= 0x007A) or -- a-z
            (codepoint == 0x00C9) or -- É
            (codepoint == 0x00E8)) then -- è

            count = count + 1
        end
    end

    return count
end


function count_uppercase_latin_characters(text)
    local count = 0

    for _, codepoint in utf8.codes(text) do
        if (codepoint >= 0x0041 and codepoint <= 0x005A) then -- A-Z
            count = count + 1
        end
    end

    return count
end

local text = service.getText(node)  


function count_lowercase_latin_characters(text)
    local count = 0

    for _, codepoint in utf8.codes(text) do
        if (codepoint >= 0x0061 and codepoint <= 0x007A) then -- a-z
            count = count + 1
        end
    end

    return count
end

function count_words(text)
    -- Replace non-breaking spaces (UTF-8: \194\160) with regular spaces
    local text_with_spaces = text:gsub("\194\160", " ")
    
    -- Count words using pattern that matches sequences of non-space characters
    local _, word_count = text_with_spaces:gsub("%S+", "")
    
    return word_count
end


function count_lines(text)
    local _, line_count = text:gsub("\n", "\n")
    return line_count + 1
end

function count_paragraphs(text)
    local _, paragraph_count = text:gsub("\n\n+", "\n\n")
    return paragraph_count + 1
end

function count_sentences(text)
    local _, sentence_count = text:gsub("[%.%!%?]+", "")
    return sentence_count
end

function count_numbers(text)
    local _, number_count = text:gsub("%d", "")
    return number_count
end

function count_arabic_numbers(text)
    local count = 0
    for _, codepoint in utf8.codes(text) do
        if codepoint >= 0x0660 and codepoint <= 0x0669 then -- Arabic digits 0-9
            count = count + 1
        end
    end
    return count
end


  local allowed_punctuations = {
    ["."] = true, [","] = true, [";"] = true, [":"] = true,
    ["!"] = true, ["?"] = true, ["؟"] = true, ["،"] = true,
    ["؛"] = true, ["("] = true, [")"] = true, ["["] = true,
    ["]"] = true, ["{"] = true, ["}"] = true, ['"'] = true,
    ["'"] = true, ["-"] = true, ["–"] = true, ["—"] = true,
    ["_"] = true, ["…"] = true, ["«"] = true, ["»"] = true,
    ["‹"] = true, ["›"] = true, ["~"] = true, ["`"] = true,
    ["@"] = true, ["#"] = true, ["$"] = true, ["%"] = true,
    ["^"] = true, ["&"] = true, ["*"] = true, ["="] = true,
    ["+"] = true, ["|"] = true, ["\\"] = true, ["/"] = true,
    ["<"] = true, [">"] = true
  }


  function count_punctuation(text)
    local punctuation_count = 0
    local utf8_char_pattern = "[%z\1-\127\194-\244][\128-\191]*"

    for uchar in text:gmatch(utf8_char_pattern) do
      if allowed_punctuations[uchar] then
        punctuation_count = punctuation_count + 1
      end
    end

    return punctuation_count
  end

  function get_unique_punctuation(text)
    local unique_punctuations = {}
    local seen_punctuations = {}
    local utf8_char_pattern = "[%z\1-\127\194-\244][\128-\191]*"

    for uchar in text:gmatch(utf8_char_pattern) do
      if allowed_punctuations[uchar] and not seen_punctuations[uchar] then
        table.insert(unique_punctuations, uchar)
        seen_punctuations[uchar] = true
      end
    end

    return unique_punctuations
  end




function count_emojis(text)
    local emoji_ranges = {
        {0x1F600, 0x1F64F}, -- Emoticons
        {0x1F300, 0x1F5FF}, -- Miscellaneous Symbols and Pictographs
        {0x1F680, 0x1F6FF}, -- Transport and Map Symbols
        {0x1F700, 0x1F77F}, -- Alchemical Symbols
        {0x1F780, 0x1F7FF}, -- Geometric Shapes Extended
        {0x1F800, 0x1F8FF}, -- Supplemental Arrows-C
        {0x1F900, 0x1F9FF}, -- Supplemental Symbols and Pictographs
        {0x1FA00, 0x1FA6F}, -- Chess Symbols
        {0x1FA70, 0x1FAFF}, -- Symbols and Pictographs Extended-A
        {0x2600, 0x26FF},   -- Miscellaneous Symbols
        {0x2700, 0x27BF},   -- Dingbats
        {0xFE00, 0xFE0F},   -- Variation Selectors
        {0x1F1E6, 0x1F1FF}, -- Regional Indicator Symbols
        {0x200D, 0x200D},   -- Zero Width Joiner
        {0x20E3, 0x20E3},   -- Combining Enclosing Keycap
        {0x1F018, 0x1F270}, -- Various Symbols
    }

    local emoji_count = 0

    for _, codepoint in utf8.codes(text) do
        for _, range in ipairs(emoji_ranges) do
            if codepoint >= range[1] and codepoint <= range[2] then
                emoji_count = emoji_count + 1
                break
            end
        end
    end

    return emoji_count
end



function count_diacritics(text)
    local diacritic_count = 0
    local diacritic_pattern = "[\216-\219][\128-\191]"  -- Arabic diacritic UTF-8 range
    
    -- Adding manually provided Arabic diacritics
    local diacritics = "ًٌٍَُِّْ"
    for _, diacritic in utf8.codes(diacritics) do
        local diacritic_utf8 = utf8.char(diacritic)
        local _, count = text:gsub(diacritic_utf8, "")
        diacritic_count = diacritic_count + count
    end
    return diacritic_count
end

function detect_text_direction(text)
    local is_rtl = false  -- افتراضيًا النص من اليسار إلى اليمين

    -- النمط الذي يعمل في اللغة العربية واللغات الأخرى التي تكتب من اليمين إلى اليسار
    local rtl_pattern = "[%z\1-\127\194-\244][\128-\191]*[\216-\219][\128-\191]*"
    
    if text:find(rtl_pattern) then
        is_rtl = true
    end
    
    return is_rtl
end


function detect_encoding(text)
    if text:sub(1, 3) == '\239\187\191' then
        return "utf-8"
    elseif text:sub(1, 2) == '\254\255' then
        return "utf-16-be"
    elseif text:sub(1, 2) == '\255\254' then
        return "utf-16-le"
    elseif text:sub(1, 4) == '\0\0\254\255' then
        return "utf-32-be"
    elseif text:sub(1, 4) == '\255\254\0\0' then
        return "utf-32-le"
    end

    local function is_utf8(s)
        return s:match("^[\194-\244][\128-\191]*$") or s:match("^[%z\1-\127]+$")
    end

    if is_utf8(text) then
        return "utf-8"
    end

    local function is_ascii(s)
        return s:match("^[%z\1-\127]*$")
    end

    if is_ascii(text) then
        return "ascii"
    end

    local function is_iso8859_1(s)
        return s:match("^[\0-\255]*$")
    end

    if is_iso8859_1(text) then
        return "iso-8859-1"
    end

    return "unknown"
end





local text = service.getText(node)  
local word_count = count_words(text)
local line_count = count_lines(text)
local character_count = count_characters(text)
local arabic_character_count = count_arabic_characters(text)
local latin_character_count = count_latin_characters(text)
local uppercase_latin_character_count = count_uppercase_latin_characters(text)
local lowercase_latin_character_count = count_lowercase_latin_characters(text)
local paragraph_count = count_paragraphs(text)
local sentence_count = count_sentences(text)
local number_count = count_numbers(text)
local arabic_number_count = count_arabic_numbers(text)
local punctuation_count = count_punctuation(text)
local unique_punctuation_list = get_unique_punctuation(text)
local emoji_count = count_emojis(text)
local diacritic_count = count_diacritics(text)
local direction = detect_text_direction(text)
local text_direction = "من اليمين إلى اليسار"
if not direction then
text_direction = "من اليسار إلى اليمين"
end

local encoding = detect_encoding(text)


print("جميعُ الأحرف: " .. character_count)
print("الأحْرُفُ العربية: " .. arabic_character_count)
print("الأحْرُفُ اللاتينية: " .. latin_character_count)
print(" الكبيرة: " .. uppercase_latin_character_count)
print(" الصغيرة: " .. lowercase_latin_character_count)
print("الكلمات: " .. word_count)
print("الْجُمَلْ: " .. sentence_count)
print("الأسطر: " .. line_count)
print("الفقرات: " .. paragraph_count)
print("الأرقامُ العربية: " .. number_count)
print("الأرقامُ الهندية:  " .. arabic_number_count)
print("العلامات: " .. punctuation_count)
print("أنواعُها:  " .. table.concat(unique_punctuation_list))
print("الإيموجي: " .. emoji_count)
print("التشكيل: " .. diacritic_count)
print("اتجاه النص: " .. text_direction)
print("ترميز النص: " .. encoding)

end,

      layout_width = "match_parent",
      layout_height = "wrap_content",
      background="#ff000000",
      textColor="#ffff00ff",
      textSize = "40sp",
      gravity = "center",
    },
  },

  {
    LinearLayout,
    orientation=0,
    layout_width="match_parent",

    {
      Button,
      text="قائمةُ التعديل",
      onClick=function(v)
        dlg.dismiss()
task(500,function()
function cpy()
require "import"
import "android.content.Context"
import "android.content.ClipData"
import "android.content.ClipboardManager"
local context = this or activity
local clipboard = context.getSystemService(Context.CLIPBOARD_SERVICE)
local textToCopy = service.getText(node) 
local clip = ClipData.newPlainText("label", textToCopy)
clipboard.setPrimaryClip(clip)
end
require "import"
import "com.androlua.LuaApplication"
if LuaApplication.getInstance().isVip()
service.execute("拆分编辑")
return true
else 
service.postClick(300,{{"%cpy",}})
service.postClick(300,{{"%暂停主语音合成$300","%输入/..$600","%拆分编辑$300", "#text1#1>10", "%清空$200","%粘贴$400", "#button1$100","%暂停主语音合成",}})
end
end)        end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },

    {
      Button,
      text="إستبدال نصي",
      onClick=function(v)
        dlg.dismiss()
        dlg.dismiss()
        require "import"
        import "android.widget.*"

        local layout = {
          LinearLayout;
          layout_width="fill";
          layout_height="fill";
          orientation="vertical";

          {
            EditText;
            id="searchEditText";
            layout_width="fill";
            layout_height="wrap";
            hint="العبارةُ المرادُ استبدالُها";
            background="#5b00ff00";
            singleLine=true;
          };

          {
            EditText;
            id="replaceEditText";
            layout_width="fill";
            layout_height="wrap";
            hint="العبارةُ البديلة";
            background="#8cff0000";
            singleLine=true;
          };
        }

        local view = loadlayout(layout)
        local content = service.getText(node)
        local dlg = LuaDialog()
        dlg.setTitle("إستبدالُ النَّص ")
        dlg.setView(view)
        dlg.setButton("إستبدال", function()
          local searchPhrase = tostring(searchEditText.getText())
          local replacePhrase = tostring(replaceEditText.getText())
          if searchPhrase ~= "" and replacePhrase ~= "" and content ~= "" then
            local newContent, _ = string.gsub(content, searchPhrase, replacePhrase)
            task(500,function()
              service.setText(newContent)
            end)
            service.postSpeak(400, "تمَّ الإستبدالُ بنجاح")
           else
            service.postSpeak(700, "الرجاء إدخال العبارةُ المرادُ استبدالُها، والعبارةُ البديلة")
          end
        end)

        dlg.setButton2("إلغاء",nil)
        dlg.show()
      end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },

    {
      Button,
      text="الإستبدالُ بالمحدَّد",
      onClick=function(v)
        dlg.dismiss()
        local o2 = service.getText(node)
        require "import"
        import "android.widget.*"
        import "android.content.*"
        import "android.view.*"

        local splitMode = "lines" -- متغير لتحديد نوع التقسيم (lines, sentences, words, paragraphs)
        local t1, t2 = {}, {}

        local function updateList()
          t1, t2 = {}, {}
          local utf8_o2 = {}
          for uchar in string.gmatch(o2, "[%z\1-\127\194-\244][\128-\191]*") do
            table.insert(utf8_o2, uchar)
          end
          if splitMode == "lines" then
            for s in string.gmatch(o2, "[^\n]+") do -- تقسيم النص بحَسَبَ الأسطر
              table.insert(t1, s)
              table.insert(t2, "")
            end
           elseif splitMode == "sentences" then
            local sentence = ""
            for _, uchar in ipairs(utf8_o2) do
              if uchar == "؟ " or uchar == "? " or uchar == "!" or uchar == ", " or uchar == "، " or uchar == "; " or uchar == "؛ " or uchar == ": " or uchar == ". " or uchar == "\n" then
                sentence = sentence .. uchar
                table.insert(t1, sentence)
                sentence = ""
               else
                sentence = sentence .. uchar
              end
            end
            if sentence ~= "" then
              table.insert(t1, sentence)
            end
            for _ = 1, #t1 do
              table.insert(t2, "")
            end
           elseif splitMode == "words" then
            for s in string.gmatch(o2, "%S+") do -- تقسيم النص إلى الكلمات
              table.insert(t1, s)
              table.insert(t2, "")
            end
           elseif splitMode == "paragraphs" then
            local paragraphs = {}
            local text = o2 .. "\n\n" -- إضافة مسافة في النهاية لضمان التقاط الفقرة الأخيرة
            for paragraph in text:gmatch("(.-)\n\n") do
              table.insert(paragraphs, paragraph)
            end

            for _, paragraph in ipairs(paragraphs) do
              paragraph = paragraph:gsub("^%s*(.-)%s*$", "%1") -- إزالة الفراغات الزائدة من الفقرة
              table.insert(t1, paragraph)
              table.insert(t2, "")
            end
          end
        end

        local o2 = service.getText(node)
        updateList(o2)

        local listDialog = LuaDialog(this)
        listDialog.setTitle("إختر نوعَ التقسيم، ثم حدِّد بالعنصرْ، أو حدِّد من وإلى عبر الضغط المطوَّل.")

        local listView = ListView(this)
        listView.setChoiceMode(ListView.CHOICE_MODE_MULTIPLE)
        listView.setBackgroundColor(0xFF000000) -- تعيين لون الخلفية إلى الأسود
        listView.setAdapter(ArrayAdapter(this, android.R.layout.simple_list_item_multiple_choice, t1))

        local startPos = -1
        local endPos = -1
        local selectedCount = 0

        listView.setOnItemClickListener(AdapterView.OnItemClickListener {
          onItemClick = function(l, v, p, i)
            selectedCount = listView.getCheckedItemCount()
            listDialog.setTitle("العناصر المحددة: " .. selectedCount)
          end
        })

        listView.setOnItemLongClickListener(AdapterView.OnItemLongClickListener {
          onItemLongClick = function(l, v, p, i)
            if startPos == -1 then
              startPos = p
              service.postSpeak(400, "تم بدء التحديد المتعدد")
             else
              endPos = p
              selectedCount = math.abs(endPos - startPos) + 1
              service.postSpeak(600, "تمَّ تحديد: " .. selectedCount)
            end

            if startPos ~= -1 and endPos ~= -1 then
              if startPos > endPos then
                local temp = startPos
                startPos = endPos
                endPos = temp
              end

              for j = startPos, endPos do
                listView.setItemChecked(j, true)
              end

              startPos = -1
              endPos = -1
              selectedCount = 0
            end

            selectedCount = listView.getCheckedItemCount()
            listDialog.setTitle("العناصر المحددة: " .. selectedCount)
            return true
          end
        })

        local layout = LinearLayout(this)
        layout.setOrientation(LinearLayout.VERTICAL)

        local splitButton = Button(this)
        splitButton.setText("تغيير التقسيم أو تحديدُ الكُل ")
        splitButton.setBackgroundColor(0xFF000000)
        splitButton.setTextColor(0xff00ffff)
        splitButton.setOnClickListener(View.OnClickListener {
          onClick = function(view)
            if splitMode == "lines" then
              splitMode = "sentences"
             elseif splitMode == "sentences" then
              splitMode = "words"
             elseif splitMode == "words" then
              splitMode = "paragraphs"
             else
              splitMode = "lines"
            end
            updateList()
            listView.setAdapter(ArrayAdapter(this, android.R.layout.simple_list_item_multiple_choice, t1))
            listDialog.setTitle(( (splitMode == "lines" and "أسطر: " .. table.size(t1) or splitMode == "sentences" and "جُمَل: " .. table.size(t1) or splitMode == "words" and "كلمات: " .. table.size(t1) or "فقرات: " .. table.size(t1))))
            service.speak( (splitMode == "lines" and "أسطر: " .. table.size(t1) or splitMode == "sentences" and "جُمَل: " .. table.size(t1) or splitMode == "words" and "كلمات: " .. table.size(t1) or "فقرات: " .. table.size(t1)))
          end
        })


        splitButton.setOnLongClickListener(View.OnLongClickListener {
          onLongClick = function(view)
            if listView.getCheckedItemCount() == listView.getCount() then
              for i = 0, listView.getCount() - 1 do
                listView.setItemChecked(i, false)
              end
             else
              for i = 0, listView.getCount() - 1 do
                listView.setItemChecked(i, true)
              end
            end
            listView.getAdapter().notifyDataSetChanged()
            listDialog.setTitle("العناصر المحددة: " .. listView.getCheckedItemCount())
            service.postSpeak(500,"العناصر المحددة: " .. listView.getCheckedItemCount())

            return true
          end
        })

        layout.addView(splitButton)

        local copyButton = Button(this)
        copyButton.setText("نَسْخ أو نَسْخ إضافي")
        copyButton.setBackgroundColor(0xFF000000)
        copyButton.setTextColor(0xff00ffff)
        copyButton.setOnClickListener(View.OnClickListener {
          onClick = function(view)
            local checkedPositions = listView.getCheckedItemPositions()
            local selectedItems = ""
            for i = 0, checkedPositions.size() - 1 do
              if checkedPositions.valueAt(i) then
                selectedItems = selectedItems .. t1[checkedPositions.keyAt(i) + 1] .. "\n"
              end
            end

            task(300, function()
              service.copy(selectedItems)
              service.postSpeak(500,"تم نسخ:"..selectedItems)
            end)

          end
        })

        copyButton.setOnLongClickListener(View.OnLongClickListener {
          onLongClick = function(view)
            local checkedPositions = listView.getCheckedItemPositions()
            local selectedItems = ""
            for i = 0, checkedPositions.size() - 1 do
              if checkedPositions.valueAt(i) then
                selectedItems = selectedItems .. t1[checkedPositions.keyAt(i) + 1] .. "\n"
              end
            end

            task(700, function()
              service.appendCopy(selectedItems)
              service.postSpeak(500,"تم إضافة:"..selectedItems)
            end)
            return true
          end
        })
        layout.addView(copyButton)

        layout.addView(listView)

        listDialog.setView(layout)

        listDialog.setButton("الإستبدالُ بالمحدَّد", function()
          local checkedPositions = listView.getCheckedItemPositions()
          local selectedItems = ""
          for i = 0, checkedPositions.size() - 1 do
            if checkedPositions.valueAt(i) then
              selectedItems = selectedItems .. t1[checkedPositions.keyAt(i) + 1].."\n"
            end
          end


          task(1000,function()
            service.setText(selectedItems)
          end)
        end)

        listDialog.setButton2("مشاركة", function()
          local checkedPositions = listView.getCheckedItemPositions()

          local selectedItems = ""
          for i = 0, checkedPositions.size() - 1 do
            if checkedPositions.valueAt(i) then
              selectedItems = selectedItems .. t1[checkedPositions.keyAt(i) + 1] .. "\n"
            end
          end

          task(300, function()
            require 'import'
            import "android.content.*"
            import "android.os.*"
            local intent = Intent(Intent.ACTION_SEND)
            .setType("text/plain")
            .putExtra(Intent.EXTRA_TEXT, selectedItems)
            this.startActivity(Intent.createChooser(intent, "مشاركة عبر:"))

          end)

        end)

        listDialog.setButton3("حفظ في ملف", function()

          local selectedItems = listView.getCheckedItemPositions()
          local favoritesCounter = 0 -- متغير لتتبع عدد العناصر المضافة للمفضلة
          local contentCounter = 1 -- متغير لتتبع فهرس المحتوى
          local selectedContent = "" -- لتخزين المحتوى المحدد مع العناوين
          local firstSevenWords = "" -- لتخزين الكلمات السبع الأولى

          for i = 0, selectedItems.size() - 1 do
            if selectedItems.valueAt(i) then
              local index = selectedItems.keyAt(i) + 1
              local title = t1[index] -- العنوان المحدد
              local content = t2[index] -- المحتوى المحدد
              selectedContent = selectedContent .. "العنصر " .. contentCounter .. ": \n" .. "عنوانه: \n"..title .. "محتواه: \n" .. content .. "\n\n"

              if firstSevenWords == "" then
                -- استخراج الكلمات السبع الأولى من النص
                local words = {}
                for word in title:gmatch("%S+") do
                  table.insert(words, word)
                  if #words == 7 then break end
                end
                firstSevenWords = table.concat(words, " ")
              end

              contentCounter = contentCounter + 1 -- زيادة الفهرس
              favoritesCounter = favoritesCounter + 1 -- زيادة عدد العناصر المضافة للمفضلة
            end
          end

          textGt = (selectedContent)
          io.mkdir("storage/emulated/0/Documents")

          firstSevenWords = firstSevenWords:gsub("[%c%p%s]", "_")

          local basePath = "/storage/emulated/0/Documents/"
          local fileName = firstSevenWords .. ".txt"
          local filePath = basePath .. fileName

          local file = io.open(filePath, "w+")
          if file then
            file:write(textGt)
            file:close()
            service.postSpeak(500, "تم حفظُ ملف: " .. fileName .. " في مُجَلَّدْ: Documents. ")
           else
            service.postSpeak(500, "فشل في حفظ الملف.")
          end
        end)


        listDialog.show()
      end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="التهجئة",
      onClick=function(v)
task(500,function()
t=service.getText(node)
for i in t:gmatch(utf8.charpattern) do
if i== " "
service.appendSpeak2("space") 
elseif i== "\n"
service.appendSpeak2("New line") 
elseif i:match("[A-Z]") then
I= i:lower()
service.appendSpeak2("capital "..I..". ")
else
service.appendSpeak2(i) 
end
end
end)        end,
onLongClickListener = {
    onLongClick = function(v)
        task(500, function()
local text =service.getText(node) 
for i = 1, #text do
    local char = text:sub(i, i)
    print(char)
end
        end)
        return true 
    end
},
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },
  },
  {
    LinearLayout,
    orientation=0,
    layout_width="match_parent",
    {
      Button,
      text="إزالةُ الأسطر الفارغة",
      onClick=function(v)
        dlg.dismiss()

        task(500,function()
          -- Function to remove empty lines from a string
          function removeEmptyLines(text)
            local result = {}
            for line in text:gmatch("[^\r\n]+") do
              if line:match("%S") then
                table.insert(result, line)
              end
            end
            return table.concat(result, "\n")
          end

          -- Example usage
          local inputText = service.getText(node)
          local outputText = removeEmptyLines(inputText)
          service.setText(outputText)
      end) end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ الأسطر الزائدة",
      onClick=function(v)
        dlg.dismiss()
        task(500,function()
          function removeExtraEmptyLines(input)
            local pattern = "\n\n+"
            local result = input:gsub(pattern, "\n\n")
            return result
          end

          -- اختبار الكود
          local text = service.getText(node)
          local cleanedText = removeExtraEmptyLines(text)
          service.setText(cleanedText)
      end) end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ المَسافاتِ الزائدة",
      onClick=function(v)
        dlg.dismiss()
        task(500,function()
          local text = service.getText(node)
          text = text:gsub(" +", " ")
          service.setText(text)
        end)
      end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ الأَحْرُفِ اللاتينية",
      onClick=function(v)
        dlg.dismiss()
        task(500,function()
utf8 = require("utf8")
function removeLatinCharacters(input)
    local result = utf8.gsub(input, "[A-Za-zÀ-ÿ]", "")
    return result
end
local text =service.getText(node)
local cleanedText = removeLatinCharacters(text)
service.setText(cleanedText)  -- يجب أن يطبع: "، هذا نص يتضمن بعض الأحرف  "
        end)
      end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },

  },
  {
    LinearLayout,
    orientation=0,
    layout_width="match_parent",
    {
      Button,
text="إزالةُ الأرقامِ العربية",
      onClick=function(v)
        dlg.dismiss()
        task(500,function()
utf8 = require("utf8")
function removeArabicNumbers(text)
    local arabic_numbers_pattern = "[0123456789]"
    local result = utf8.gsub(text, arabic_numbers_pattern, "")
    return result
end
local input = service.getText(node)
local output = removeArabicNumbers(input)
service.setText(output)  -- يجب أن يطبع "مرحبا "
        end)
      end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ الأرقامِ الهندية",
      onClick=function(v)
        dlg.dismiss()
        task(500,function()
utf8 = require("utf8")
function removeArabicNumbers(text)
    local arabic_numbers_pattern = "[٠١٢٣٤٥٦٧٨٩]"
    local result = utf8.gsub(text, arabic_numbers_pattern, "")
    return result
end
local input = service.getText(node)
local output = removeArabicNumbers(input)
service.setText(output)  -- يجب أن يطبع "مرحبا "
        end)
      end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إستبدالُ الأرقامِ الهنديةِ بالعربية",
      onClick=function(v)
        dlg.dismiss()

task(500,function()
function replace_arabic_numbers(text)
    local arabic_to_english = {
        ["٠"] = "0", ["١"] = "1", ["٢"] = "2", ["٣"] = "3", ["٤"] = "4",
        ["٥"] = "5", ["٦"] = "6", ["٧"] = "7", ["٨"] = "8", ["٩"] = "9"
    }
    text = text:gsub("٠", arabic_to_english["٠"])
    text = text:gsub("١", arabic_to_english["١"])
    text = text:gsub("٢", arabic_to_english["٢"])
    text = text:gsub("٣", arabic_to_english["٣"])
    text = text:gsub("٤", arabic_to_english["٤"])
    text = text:gsub("٥", arabic_to_english["٥"])
    text = text:gsub("٦", arabic_to_english["٦"])
    text = text:gsub("٧", arabic_to_english["٧"])
    text = text:gsub("٨", arabic_to_english["٨"])
    text = text:gsub("٩", arabic_to_english["٩"])

    return text
end
local text = service.getText(node)
local translated_text = replace_arabic_numbers(text)
service.setText(translated_text)  -- السعر هو 150 ريال
end)       end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
text="إستبدالُ الأرقامِ العربيةِ بالهندية",
      onClick=function(v)
        dlg.dismiss()
task(500,function()
function replace_english_numbers(text)
    local english_to_arabic = {
        ["0"] = "٠", ["1"] = "١", ["2"] = "٢", ["3"] = "٣", ["4"] = "٤",
        ["5"] = "٥", ["6"] = "٦", ["7"] = "٧", ["8"] = "٨", ["9"] = "٩"
    }
    text = text:gsub("0", english_to_arabic["0"])
    text = text:gsub("1", english_to_arabic["1"])
    text = text:gsub("2", english_to_arabic["2"])
    text = text:gsub("3", english_to_arabic["3"])
    text = text:gsub("4", english_to_arabic["4"])
    text = text:gsub("5", english_to_arabic["5"])
    text = text:gsub("6", english_to_arabic["6"])
    text = text:gsub("7", english_to_arabic["7"])
    text = text:gsub("8", english_to_arabic["8"])
    text = text:gsub("9", english_to_arabic["9"])
    return text
end
local text = service.getText(node)
local translated_text = replace_english_numbers(text)
service.setText(translated_text)  -- The price is ١٥٠ dollars
end)        end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
  },
  {
    LinearLayout,
    orientation=0,
    layout_width="match_parent",
    {
      Button,
      text="إستبدالُ العَلاماتِ بالمَسافة",
      onClick=function(v)
        dlg.dismiss()
task(500,function()
utf8 = require("utf8")

function remove_punctuation_and_normalize_spaces(text)
    -- تعريف نمط لجميع علامات الترقيم الإنجليزية والعربية
    local punctuation_pattern = "[%p٪٪،؛؟!؟ـ-]"
    -- استبدال علامات الترقيم بمسافات
    local result = utf8.gsub(text, punctuation_pattern, " ")
    -- إزالة المسافات الزائدة والإبقاء على مسافة واحدة، مع الحفاظ على الأسطر الجديدة
    result = utf8.gsub(result, "[%s]+", function(space)
        if space:find("\n") then
            return "\n"
        else
            return " "
        end
    end)
    -- إزالة المسافات في البداية والنهاية لكل سطر إن وجدت
    result = utf8.gsub(result, "[ \t]+$", "")
    result = utf8.gsub(result, "^[ \t]+", "")
    return result
end

local original_text = service.getText(node)
local clean_text = remove_punctuation_and_normalize_spaces(original_text)
service.setText(clean_text) -- النتيجة: "مرحبًا كيف حالك\nهذا مثال"
end)               end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إستبدالُ الإيموجي بالمَسافة",
      onClick=function(v)
        dlg.dismiss()
task(500,function()
function removeEmojis(text)
    local emoji_ranges = {
        {0x1F600, 0x1F64F}, -- Emoticons
        {0x1F300, 0x1F5FF}, -- Miscellaneous Symbols and Pictographs
        {0x1F680, 0x1F6FF}, -- Transport and Map Symbols
        {0x1F700, 0x1F77F}, -- Alchemical Symbols
        {0x1F780, 0x1F7FF}, -- Geometric Shapes Extended
        {0x1F800, 0x1F8FF}, -- Supplemental Arrows-C
        {0x1F900, 0x1F9FF}, -- Supplemental Symbols and Pictographs
        {0x1FA00, 0x1FA6F}, -- Chess Symbols
        {0x1FA70, 0x1FAFF}, -- Symbols and Pictographs Extended-A
        {0x2600, 0x26FF},   -- Miscellaneous Symbols
        {0x2700, 0x27BF},   -- Dingbats
        {0xFE00, 0xFE0F},   -- Variation Selectors
        {0x1F1E6, 0x1F1FF}, -- Regional Indicator Symbols
        {0x1F900, 0x1F9FF}, -- Supplemental Symbols and Pictographs
        {0x200D, 0x200D},   -- Zero Width Joiner
        {0x20E3, 0x20E3},   -- Combining Enclosing Keycap
        {0x1F018, 0x1F270}, -- Various Symbols
    }

    local function isEmoji(char)
        local code = utf8.codepoint(char)
        for _, range in ipairs(emoji_ranges) do
            if code >= range[1] and code <= range[2] then
                return true
            end
        end
        return false
    end

    local clean_text = ""
    for _, char in utf8.codes(text) do
        local character = utf8.char(char)
        if isEmoji(character) then
            clean_text = clean_text .. " "
        else
            clean_text = clean_text .. character
        end
    end

    -- إزالة المسافات الزائدة المتتالية مع الحفاظ على الأسطر الجديدة
    clean_text = clean_text:gsub("[ \t]+", " ")

    return clean_text
end

local input = service.getText(node)
local output = removeEmojis(input)
service.setText(output)  -- الناتج: "Hello ! How are you ?"
end)        end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إستبدالُ المَسافةِ الغير مكسورة",
      onClick=function(v)
        dlg.dismiss()
task(500,function()
local spaceReplacementCode = " " -- استخدام المسافة العادية
local originalText = service.getText(node)
local replacedText = string.gsub(originalText, "\194\160", spaceReplacementCode)
service.setText(replacedText)
end)        end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إستبدالُ الأسطُرِ بالمسافَات",
      onClick=function(v)
        dlg.dismiss()

        task(500,function()
          -- Define the function to replace newlines with spaces
          function replace_newlines_with_spaces(input)
            -- Use gsub to replace all newline characters with spaces
            local output = input:gsub("\n", " ")
            return output
          end

          -- Example usage
          local text = service.getText(node)
          local result = replace_newlines_with_spaces(text)
          service.setText(result) -- Output: "This is a line
      end) end,
      textSize="11sp",
      background="#ff000000",
      textColor="#ffffffff",

      layout_width="0dp",
      layout_weight=1,
    },
  },
  {
    LinearLayout,
    orientation=0,
    layout_width="match_parent",
    {
      Button,
      text="تصغيرُ الاحرف الكبيرة",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function convertToLower(text)
    return string.lower(text)
end
local text = service.getText(node) 
local lower_text = convertToLower(text)
service.setText(lower_text)
end)  
      end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="تكْبيرُ الأَحْرُفِ الصغيرة",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function convertToUpper(text)
    return string.upper(text)
end
local text = service.getText(node) 
local upper_text = convertToUpper(text)
service.setText(upper_text)
end)                end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="تكْبيرُ الحرفِ الأوَّل",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function capitalizeText(text)
    -- Helper function to capitalize the first letter of a word
    local function capitalizeFirstLetter(word)
        return word:sub(1,1):upper() .. word:sub(2)
    end
    -- Capitalize the first letter of the text
    text = capitalizeFirstLetter(text)

    -- Patterns to find sentences ending with !, ?, ., !\n, ?\n, .\n
    local patterns = {
        "([!?.]%s*)([a-z])",       -- For cases like "hello! how"
        "([!?.][\n]%s*)([a-z])",   -- For cases like "hello!\nhow"
    }
    -- Function to capitalize the letter after punctuation
    local function capitalizeAfterPunctuation(punctuation, letter)
        return punctuation .. letter:upper()
    end
    -- Apply the patterns to the text
    for _, pattern in ipairs(patterns) do
        text = text:gsub(pattern, capitalizeAfterPunctuation)
    end
    return text
end
-- Test the function
local testText = service.getText(node) 
local result = capitalizeText(testText)
service.setText(result)  -- Output: "Hello! \nHow are you? \nThis is a test.\nLet's see if it works."
end)          end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",

      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إستثناءُ اللغاتِ اللاتينية",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function remove_non_latin(input)
    return input:gsub("[^%a%s]", "")
end
local text = service.getText(node) 
local cleaned_text = remove_non_latin(text)
service.setText(cleaned_text)
end)         end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },
  },
  {
    LinearLayout,
    orientation=0,
layout_width="match_parent",
    {
      Button,
      text="إزالةُ المَسافاتِ أوَّلَ السَّطْرْ",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function trim_start_spaces_multiline(str)
    -- استخدم النمط "global" لإزالة المسافات من بداية كل سطر
    return (str:gsub("\n%s+", "\n"):gsub("^%s+", ""))
end
local input = service.getText(node)
local trimmed = trim_start_spaces_multiline(input)
service.setText(trimmed)
end)         end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ المَسافاتِ آخِرَ السَّطْرْ",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function trim_end_spaces_multiline(str)
    -- استخدم النمط "global" لإزالة المسافات من نهاية كل سطر
    return (str:gsub("%s+\n", "\n"):gsub("%s+$", ""))
end
local input = service.getText(node)
local trimmed = trim_end_spaces_multiline(input)
service.setText(trimmed)
end)         end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ الكلماتِ المُكَرَّرَةِ المُتَتَالِيَة",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function remove_consecutive_duplicates(str)
    local result = {}
    local prev_word = nil
    for line in str:gmatch("[^\n]*") do
        local words = {}
        for word in line:gmatch("%S+") do
            table.insert(words, word)
        end
        for i, word in ipairs(words) do
            local clean_word = word:gsub("[%p%c]", "")
            if clean_word ~= prev_word then
                table.insert(result, word)
                prev_word = clean_word
            end
        end
        if line ~= "" then
            table.insert(result, "\n")
        end
    end
    return table.concat(result, " ")
end
local input = service.getText(node) 
local output = remove_consecutive_duplicates(input)
service.setText(output)
end)         end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },
    {
      Button,
      text="إزالةُ الأَسْطُرِ المُكَرَّرَةِ المُتَتَالِيَة",
      onClick=function(v)
        dlg.dismiss()
task(500, function()
function remove_consecutive_duplicates(str)
    local result = {}
    local prev_line = nil
    local has_newline = str:sub(-1) == '\n' -- تحقق مما إذا كانت هناك سطر جديد في نهاية النص
    for line in str:gmatch("[^\n]*\n?") do
        if line ~= prev_line then
            table.insert(result, line)
            prev_line = line
        end
    end
    if has_newline and prev_line == "" then
        table.insert(result, prev_line)
    end
    return table.concat(result, "")
end
local input = service.getText(node) 
local output = remove_consecutive_duplicates(input)
service.setText(output)
end)         end,
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
},

},
  {
    LinearLayout,
    orientation=0,
layout_width="match_parent",
    {
      Button,
      text="تَجاهُلُ الأَسْطُرِ المُكَرَّرَة",
onClick=function(v)
task(500, function()
    local text = service.getText(node)
    local lines = {}
    local unique_lines = {}
    for line in text:gmatch("[^\r\n]+") do
        if not lines[line] then
            lines[line] = true
            table.insert(unique_lines, line)
        end
    end
    for _, line in ipairs(unique_lines) do
        print(line)
    end
end)
end,

onLongClickListener = { onLongClick = function(v)
task(500, function()
    local text = service.getText(node)
    local lines = {}
    local unique_lines = {}
    for line in text:gmatch("[^\r\n]+") do
        if not lines[line] then
            lines[line] = true
            table.insert(unique_lines, line)
        end
    end
    local all_text = table.concat(unique_lines, "\n")
    service.copy(all_text)
end)
    return true 
end },
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },

    {
      Button,
text="الأَسْطُرُ المُكَرَّرَة",
onClick=function(v)
    task(500, function()
        local text = service.getText(node)
        local line_counts = {}
        local repeated_lines = {}
        for line in text:gmatch("[^\r\n]+") do
            line_counts[line] = (line_counts[line] or 0) + 1
        end
        for line, count in pairs(line_counts) do
            if count > 1 then
                table.insert(repeated_lines, line)
            end
        end
        for _, line in ipairs(repeated_lines) do
            print(line)
        end
    end)
end,

onLongClickListener = {
    onLongClick = function(v)
        task(500, function()
            local text = service.getText(node)
            local line_counts = {}
            local repeated_lines = {}
            for line in text:gmatch("[^\r\n]+") do
                line_counts[line] = (line_counts[line] or 0) + 1
            end
            for line, count in pairs(line_counts) do
                if count > 1 then
                    table.insert(repeated_lines, line)
                end
            end
            local repeated_text = table.concat(repeated_lines, "\n")
            service.copy(repeated_text)
        end)
        return true 
    end
},
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },

    {
      Button,
text="الأَسْطُرُ المُنْفَرِدَة",
onClick=function(v)
task(500, function()
    local text = service.getText(node)
    local line_counts = {}
    local unique_lines = {}

    for line in text:gmatch("[^\r\n]+") do
        line_counts[line] = (line_counts[line] or 0) + 1
    end

    for line, count in pairs(line_counts) do
        if count == 1 then
            table.insert(unique_lines, line)
        end
    end

    for _, line in ipairs(unique_lines) do
        print(line)
    end
end)         
end,

onLongClickListener = { 
    onLongClick = function(v)
        task(500, function()
            local text = service.getText(node)
            local line_counts = {}
            local unique_lines = {}

            for line in text:gmatch("[^\r\n]+") do
                line_counts[line] = (line_counts[line] or 0) + 1
            end

            for line, count in pairs(line_counts) do
                if count == 1 then
                    table.insert(unique_lines, line)
                end
            end

            local all_unique_text = table.concat(unique_lines, "\n")
            service.copy(all_unique_text)
        end)
        return true 
    end 
},
      textColor="#ffffffff",
      textSize="11sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
    },

{
    Button,
    text="إزالةُ الأَسْطُرِ المُكَرَّرَة",
    onClick=function(v)
        dlg.dismiss()
        task(500, function()
            function remove_duplicates(str)
                local result = {}
                local lines_seen = {}
                for line in str:gmatch("[^\r\n]+") do
                    if not lines_seen[line] then
                        table.insert(result, line)
                        lines_seen[line] = true
                    end
                end
                return table.concat(result, "\n")
            end
            local input = service.getText(node)
            local output = remove_duplicates(input)
            service.setText(output)
        end)
    end,
onLongClickListener = { 
    onLongClick = function(v)
        task(500, function()
        end)
        return true 
    end 
},
    textColor="#ffffffff",
    textSize="11sp",
    background="#ff000000",
    layout_width="0dp",
    layout_weight=1,
},
},

  {
    LinearLayout,
    orientation=0,
layout_width="match_parent",
{
  Button,
  text="عَرْضُ الاسطر حَسَبَ البداية",
  onClick=function(v)
    dlg.dismiss()
require "import"
import "android.widget.*"

local layout = {
  LinearLayout;
  layout_width="fill";
  layout_height="fill";
  orientation="vertical";

  {
    EditText;
    id="searchEditText";
    layout_width="fill";
    layout_height="wrap";
    hint="ضع بِدايات الأسطر المراد عرضها (سطْرٌ لكل عِبارة)";
    background="#5b00ff00";
    singleLine=false; 
  };
}

local view = loadlayout(layout)
local content = service.getText(node)
local dlg = LuaDialog()
dlg.setTitle("عرض أسطر محددة")
dlg.setView(view)
dlg.setButton("عرض", function()
  local searchText = tostring(searchEditText.getText())
  if searchText ~= "" and content ~= "" then
    
    local phrasesToSearch = {}
    for phrase in searchText:gmatch("[^\n]+") do
      table.insert(phrasesToSearch, phrase)
    end
    
    local function showLinesStartingWith(text, phrases)
      local result = {}
      local linesFound = 0
      for line in text:gmatch("[^\r\n]+") do
        for _, phrase in ipairs(phrases) do
          if line:find("^" .. phrase) then
            table.insert(result, line)
            linesFound = linesFound + 1
            break
          end
        end
      end
      return result, linesFound
    end
    

    local matchedLines, linesFound = showLinesStartingWith(content, phrasesToSearch)
    

    if linesFound > 0 then
      print("تم العثور على " .. linesFound .. " سطر/أسطر:")
      for _, line in ipairs(matchedLines) do
        print(line)
      end
    else
      print("لم يتم العثور على أي سطر مطابق للعبارات المدخلة")
    end
  else
    print("الرجاء إدخال العبارات المراد البحث عنها")
  end
end)

dlg.setButton2("إلغاء",nil)
dlg.show()
  end,
onLongClickListener = { 
    onLongClick = function(v)
dlg.dismiss()
        task(500, function()
require "import"
import "android.widget.*"

local layout = {
  LinearLayout;
  layout_width="fill";
  layout_height="fill";
  orientation="vertical";

  {
    EditText;
    id="searchEditText";
    layout_width="fill";
    layout_height="wrap";
    hint="ضع بِدايات الأسطر المراد نَسْخُها (سطْرٌ لكل عِبارة)";
    background="#5b00ff00";
    singleLine=false; 
  };
}

local view = loadlayout(layout)
local content = service.getText(node)
local dlg = LuaDialog()
dlg.setTitle("نسخ أسطر محددة")
dlg.setView(view)
dlg.setButton("نسخ", function()
  local searchText = tostring(searchEditText.getText())
  if searchText ~= "" and content ~= "" then
    
    local phrasesToSearch = {}
    for phrase in searchText:gmatch("[^\n]+") do
      table.insert(phrasesToSearch, phrase)
    end
    
    local function showLinesStartingWith(text, phrases)
      local result = {}
      local linesFound = 0
      for line in text:gmatch("[^\r\n]+") do
        for _, phrase in ipairs(phrases) do
          if line:find("^" .. phrase) then
            table.insert(result, line)
            linesFound = linesFound + 1
            break
          end
        end
      end
      return table.concat(result, "\n"), linesFound
    end
    
    local matchedLines, linesFound = showLinesStartingWith(content, phrasesToSearch)
    
    if linesFound > 0 then
service.postSpeak(1500,"تم نسخ: " .. linesFound .. " من الأسطر" )   
service.copy(matchedLines)
    else
      print("لم يتم العثور على أي سطر مطابق للعبارات المدخلة")
    end
  else
    print("الرجاء إدخال العبارات المراد البحث عنها")
  end
end)

dlg.setButton2("إلغاء",nil)
dlg.show()

        end)
        return true 
    end 
},
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},

{
  Button,
  text="عَرْضُ الاسطر حَسَبَ النهاية",
  onClick=function(v)
    dlg.dismiss()
require "import"
import "android.widget.*"

local layout = {
  LinearLayout;
  layout_width="fill";
  layout_height="fill";
  orientation="vertical";

  {
    EditText;
    id="searchEditText";
    layout_width="fill";
    layout_height="wrap";
    hint="ضع نِهايات الأسطر المراد عرضها (سطْرٌ لكل عِبارة)";
    background="#5b00ff00";
    singleLine=false; 
  };
}

local view = loadlayout(layout)
local content = service.getText(node)
local dlg = LuaDialog()
dlg.setTitle("عرض أسطر محددة")
dlg.setView(view)
dlg.setButton("عرض", function()
  local searchText = tostring(searchEditText.getText())
  if searchText ~= "" and content ~= "" then
    
    local phrasesToSearch = {}
    for phrase in searchText:gmatch("[^\n]+") do
      table.insert(phrasesToSearch, phrase)
    end
    
    local function showLinesEndingWith(text, phrases)
      local result = {}
      local linesFound = 0
      for line in text:gmatch("[^\r\n]+") do
        for _, phrase in ipairs(phrases) do
          if line:find(phrase .. "$") then -- التحقق من أن السطر ينتهي بالعبارة
            table.insert(result, line)
            linesFound = linesFound + 1
            break
          end
        end
      end
      return result, linesFound
    end
    

    local matchedLines, linesFound = showLinesEndingWith(content, phrasesToSearch)
    

    if linesFound > 0 then
      print("تم العثور على " .. linesFound .. " سطر/أسطر:")
      for _, line in ipairs(matchedLines) do
        print(line)
      end
    else
      print("لم يتم العثور على أي سطر مطابق للعبارات المدخلة")
    end
  else
    print("الرجاء إدخال العبارات المراد البحث عنها")
  end
end)

dlg.setButton2("إلغاء",nil)
dlg.show()
  end,
onLongClickListener = { 
    onLongClick = function(v)
dlg.dismiss()
        task(500, function()
require "import"
import "android.widget.*"

local layout = {
  LinearLayout;
  layout_width="fill";
  layout_height="fill";
  orientation="vertical";

  {
    EditText;
    id="searchEditText";
    layout_width="fill";
    layout_height="wrap";
    hint="ضع نهايات الأسطر المراد نَسْخُها (سطْرٌ لكل عِبارة)";
    background="#5b00ff00";
    singleLine=false; 
  };
}

local view = loadlayout(layout)
local content = service.getText(node)
local dlg = LuaDialog()
dlg.setTitle("نسخ أسطر محددة")
dlg.setView(view)
dlg.setButton("نسخ", function()
  local searchText = tostring(searchEditText.getText())
  if searchText ~= "" and content ~= "" then
    local phrasesToSearch = {}
    for phrase in searchText:gmatch("[^\n]+") do
      table.insert(phrasesToSearch, phrase)
    end
    
    local function showLinesEndingWith(text, phrases)
      local result = {}
      local linesFound = 0
      for line in text:gmatch("[^\r\n]+") do
        for _, phrase in ipairs(phrases) do
          if line:find(phrase .. "$") then
            table.insert(result, line)
            linesFound = linesFound + 1
            break
          end
        end
      end
      return table.concat(result, "\n"), linesFound
    end
    
    local matchedLines, linesFound = showLinesEndingWith(content, phrasesToSearch)
    
    if linesFound > 0 then
service.postSpeak(1500,"تم نسخ: " .. linesFound .. " من الأسطر" )   
service.copy(matchedLines)
    else
      print("لم يتم العثور على أي سطر مطابق للعبارات المدخلة")
    end
  else
    print("الرجاء إدخال العبارات المراد البحث عنها")
  end
end)

dlg.setButton2("إلغاء",nil)
dlg.show()
        end)
        return true 
    end 
},
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},

{
  Button,
  text="حَذْفُ الاسطر حَسَبَ البداية",
  onClick=function(v)
    dlg.dismiss()
require "import"
import "android.widget.*"

local layout = {
  LinearLayout;
  layout_width="fill";
  layout_height="fill";
  orientation="vertical";

  {
    EditText;
    id="searchEditText";
    layout_width="fill";
    layout_height="wrap";
    hint="ضع بِدايات الأسطر المراد حذْفُهَا (سطْرٌ لكل عِبارة)";
    background="#5b00ff00";
    singleLine=false; 
  };
}

local view = loadlayout(layout)
local content = service.getText(node)
local dlg = LuaDialog()
dlg.setTitle("حذف أسطر محددة")
dlg.setView(view)
dlg.setButton("حذف", function()
  local searchText = tostring(searchEditText.getText())
  if searchText ~= "" and content ~= "" then
    local phrasesToRemove = {}
    for phrase in searchText:gmatch("[^\n]+") do
      table.insert(phrasesToRemove, phrase)
    end
    
    local function removeLinesStartingWith(text, phrases)
      local result = {}
      local linesRemoved = 0
      for line in text:gmatch("[^\r\n]+") do
        local shouldRemove = false
        for _, phrase in ipairs(phrases) do
          if line:find("^" .. phrase) then
            shouldRemove = true
            linesRemoved = linesRemoved + 1
            break
          end
        end
        if not shouldRemove then
          table.insert(result, line)
        end
      end
      return table.concat(result, "\n"), linesRemoved
    end
    
    local newContent, linesRemoved = removeLinesStartingWith(content, phrasesToRemove)
    task(500,function()
      service.setText(newContent)
    end)
    
    if linesRemoved > 0 then
      service.postSpeak(1400, "تم حذف " .. linesRemoved .. "من الأسطر")
    else
      service.postSpeak(400, "لم يتم العثور على أي سطر مطابق للعبارات المدخلة")
    end
  else
    service.postSpeak(700, "الرجاء إدخال العبارات المراد حذفها")
  end
end)

dlg.setButton2("إلغاء",nil)
dlg.show()
  end,
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},

{
  Button,
  text="حَذْفُ الاسطر حَسَبَ النهاية",
  onClick=function(v)
    dlg.dismiss()
require "import"
import "android.widget.*"

local layout = {
  LinearLayout;
  layout_width="fill";
  layout_height="fill";
  orientation="vertical";

  {
    EditText;
    id="searchEditText";
    layout_width="fill";
    layout_height="wrap";
    hint="ضع نهايات الأسطر المراد حذْفُهَا (سطْرٌ لكل عِبارة)";
    background="#5b00ff00";
    singleLine=false; 
  };
}
local view = loadlayout(layout)
local content = service.getText(node)
local dlg = LuaDialog()
dlg.setTitle("حذف أسطر محددة")
dlg.setView(view)
dlg.setButton("حذف", function()
  local searchText = tostring(searchEditText.getText())
  if searchText ~= "" and content ~= "" then
    local phrasesToRemove = {}
    for phrase in searchText:gmatch("[^\n]+") do
      table.insert(phrasesToRemove, phrase)
    end
    local function removeLinesEndingWith(text, phrases)
      local result = {}
      local linesRemoved = 0
      for line in text:gmatch("[^\r\n]+") do
        local shouldRemove = false
        for _, phrase in ipairs(phrases) do
          if line:find(phrase .. "$") then
            shouldRemove = true
            linesRemoved = linesRemoved + 1
            break
          end
        end
        if not shouldRemove then
          table.insert(result, line)
        end
      end
      return table.concat(result, "\n"), linesRemoved
    end
    local newContent, linesRemoved = removeLinesEndingWith(content, phrasesToRemove)
    task(500,function()
      service.setText(newContent)
    end)
    if linesRemoved > 0 then
      service.postSpeak(1400, "تم حذف " .. linesRemoved .. "من الأسطر")
    else
      service.postSpeak(400, "لم يتم العثور على أي سطر مطابق للعبارات المدخلة")
    end
  else
    service.postSpeak(700, "الرجاء إدخال العبارات المراد حذفها")
  end
end)
dlg.setButton2("إلغاء",nil)
dlg.show()
  end,
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},
},
  {
    LinearLayout,
    orientation=0,
layout_width="match_parent",
{
  Button,
  text="إضافة الترقيم للأسطر أو إزالته.",
  onClick=function(v)
    dlg.dismiss()
task(500, function()
local text = service.getText(node)
local function split_into_lines(text)
    local lines = {}
    for line in text:gmatch("[^\r\n]+") do
        table.insert(lines, line)
    end
    return lines
end
local function number_lines(lines)
    for i, line in ipairs(lines) do
        lines[i] = i .. ": " .. line
    end
end
local function join_lines(lines)
    return table.concat(lines, "\n")
end
local lines = split_into_lines(text)
number_lines(lines)
local numbered_text = join_lines(lines)

if service.isEditable(node)
service.setText(numbered_text)
else
print(numbered_text)
end
end)
  end,
onLongClickListener = { 
    onLongClick = function(v)
dlg.dismiss()
        task(500, function()
local text = service.getText(node)
local function split_into_lines(text)
    local lines = {}
    for line in text:gmatch("[^\r\n]+") do
        table.insert(lines, line)
    end
    return lines
end
local function remove_line_numbers(lines)
    for i, line in ipairs(lines) do
        -- احذف الرقم وأي علامة ترقيمية أو مسافة بعده
        lines[i] = line:gsub("^%d+[%p%s]*", "")
    end
end
local function join_lines(lines)
    return table.concat(lines, "\n")
end
local lines = split_into_lines(text)
remove_line_numbers(lines)
local cleaned_text = join_lines(lines)
if service.isEditable(node) then
    service.setText(cleaned_text)
else
    print(cleaned_text)
end
        end)
        return true 
    end 
},
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},
{
  Button,
  text="ترتيب الأسطر هجائيا أو العكس",
  onClick=function(v)
    dlg.dismiss()
task(500, function()
local text = service.getText(node)
local lines = {}
for line in text:gmatch("[^\r\n]+") do
    table.insert(lines, line)
end
table.sort(lines, function(a, b)
    return a:lower() < b:lower()
end)
if service.isEditable(node) then
    local sortedText = table.concat(lines, "\n")
    service.setText(sortedText)
else
    for _, line in ipairs(lines) do
        print(line)
    end
end
end)
  end,
onLongClickListener = { 
    onLongClick = function(v)
dlg.dismiss()
        task(500, function()
local text = service.getText(node)
local lines = {}
for line in text:gmatch("[^\r\n]+") do
    table.insert(lines, line)
end
table.sort(lines, function(a, b)
    return a:lower() < b:lower()
end)
local reversedLines = {}
for i = #lines, 1, -1 do
    table.insert(reversedLines, lines[i])
end
if service.isEditable(node) then
    local sortedText = table.concat(reversedLines, "\n")
    service.setText(sortedText)
else
    for _, line in ipairs(reversedLines) do
        print(line)
    end
end
        end)
        return true 
    end 
},
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},
{
  Button,
  text="عرض الأسطر دون شيء قبل النص أو بعده",
  onClick=function(v)
    dlg.dismiss()
require "import"
task(500, function()
    local text = service.getText(node)
    
    -- دالة لحذف الأرقام، الرموز، المسافات، والعلامات المحددة في بداية السطر
    local function remove_leading_characters(line)
        return line:gsub("^[%d%p%s،؟؛]+", "")
    end
    
    -- تقسيم النص إلى أسطر
    for line in text:gmatch("[^\r\n]+") do
        -- تنظيف السطر وطباعة النتيجة
        local cleaned_line = remove_leading_characters(line)
        print(cleaned_line)
    end
end)
  end,
onLongClickListener = { 
    onLongClick = function(v)
dlg.dismiss()
require "import"
task(500, function()
    local text = service.getText(node)
    local function remove_trailing_characters(line)
        return line:gsub("[%d%p%s،؟؛]+$", "")
    end
    for line in text:gmatch("[^\r\n]+") do
        local cleaned_line = remove_trailing_characters(line)
        print(cleaned_line)
    end
end)
        return true 
    end 
},
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},

{
  Button,
  text="حذف الكل في السطر قبل النص أو بعده",
  onClick=function(v)
    dlg.dismiss()
require "import"
task(500, function()
    local text = service.getText(node)
    local function remove_leading_characters(line)
        return line:gsub("^[%d%p%s،؟؛]+", "")
    end
    local cleaned_text = ""
    for line in text:gmatch("[^\r\n]+") do
        local cleaned_line = remove_leading_characters(line)
        cleaned_text = cleaned_text .. cleaned_line .. "\n"
    end
    cleaned_text = cleaned_text:gsub("\n$", "")
    service.setText(cleaned_text)
end)
  end,
onLongClickListener = { 
    onLongClick = function(v)
dlg.dismiss()
require "import"
task(500, function()
    local text = service.getText(node)
    local function remove_trailing_characters(line)
        return line:gsub("[%d%p%s،؟؛]+$", "")
    end
    local cleaned_text = ""
    for line in text:gmatch("[^\r\n]+") do
        local cleaned_line = remove_trailing_characters(line)
        cleaned_text = cleaned_text .. cleaned_line .. "\n"
    end
    cleaned_text = cleaned_text:gsub("\n$", "")
    service.setText(cleaned_text)
end)
        return true 
    end 
},
  textSize="11sp",
  background="#ff000000",
  textColor="#ffffffff",
  layout_width="0dp",
  layout_weight=1,
},
}
}

dlg=LuaDialog()
dlg.setView(loadlayout(layout))
dlg.show()