require 'import'
import "android.widget.EditText"


dir = package.searchpath("main", package.path):match("(.*)main.lua")
dir2=package.searchpath("main",package.path):match("(.*)main.lua").."Applications/"
dir3=package.searchpath("main",package.path):match("(.*)main.lua").."launcher/"


function pastePasswordBaridiMob()
  local file_path = "/storage/emulated/0/Documents/comfortableDictation/baridiMob.txt"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    file_read:close()
    if content ~= "" then
      service.setText(content)
      return true
     else
      LuaDialog()
      .setTitle("لا يوجد محتوى")
      .setMessage("الملف موجود لكن لا يحتوي على كلمة مرور.")
      .setPositiveButton("تحديث كلمة المرور", function()updatePasswordBaridiMob () end)
      .setNegativeButton("إلغاء", function() end)
      .show()
    end
   else
    LuaDialog()
    .setTitle("خطأ في القراءة")
    .setMessage("تعذر فتح الملف لقراءة كلمة المرور.")
    .setPositiveButton("تحديث كلمة المرور", function()updatePasswordBaridiMob () end)
    .setNegativeButton("إلغاء", function() end)
    .show()
    return true
  end
  return
end





function updatePasswordBaridiMob()
  -- التأكد من وجود المجلد والملف
  local file_path = "/storage/emulated/0/Documents/comfortableDictation/baridiMob.txt"
  io.mkdir("/storage/emulated/0/Documents/")
  io.mkdir("/storage/emulated/0/Documents/comfortableDictation")
  io.open(file_path, "a"):close()
  local dlg = LuaDialog()
  local edit = loadlayout{
    EditText,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "كلمة المرور الجديدة"
  }
  edit.setBackgroundColor(0xFF00008B)

  -- قراءة كلمة المرور الحالية (إن وُجدت)
  local current_password = "غير معروفة"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    if content ~= "" then
      current_password = content
    end
    file_read:close()
  end

  dlg.setTitle("تحديث كلمة المرور")
  dlg.setMessage("كلمة المرور الحالية:\n" .. current_password)
  dlg.setView(edit)
  edit.setContentDescription("أدخل كلمة المرور الجديدة هنا, ثم تحقق منها عبر التمرير للأسفل أو للأعلى.")

  dlg.setButton("حفظ", function()
    local new_password = tostring(edit.getText())
    if new_password and new_password ~= "" then
      local f = io.open(file_path, "w")
      if f then
        f:write(new_password .. "\n")
        f:close()

        local successDialog = LuaDialog(service)
        successDialog.setTitle("تم تحديث كلمة المرور")
        successDialog.setMessage("تم حفظ كلمة المرور:\n" .. new_password)
        successDialog.setCancelable(false)
        successDialog.setOnKeyListener(luajava.createProxy("android.content.DialogInterface$OnKeyListener", {
          onKey = function(d, keyCode, event)
            if keyCode == 4 then
              service.speak("اضغط على موافق للتنفيذْ, أو على إعادة المحاولة لإدخال كلمة المرور مجدداً")
              return true
            end
            return false
          end
        }))
        successDialog.setPositiveButton("موافق", function() os.exit(0) end)
        successDialog.setNegativeButton("إعادة المحاولة", function() updatePasswordBaridiMob() end)
        successDialog.show()
       else
        LuaDialog()
        .setTitle("خطأ في الكتابة")
        .setMessage("تعذر فتح الملف للكتابة.")
        .setPositiveButton("موافق", function() end)
        .show()
      end
     else
      LuaDialog()
      .setTitle("تنبيه")
      .setMessage("الرجاء إدخال كلمة مرور جديدة")
      .setPositiveButton("إعادة المحاولة", function() updatePasswordBaridiMob() end)
      .show()
    end
  end)

  dlg.setNegativeButton("إلغاء", function() dlg.dismiss() end)
  dlg.show()
end





local luajava = require("luajava")
local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
local Intent = luajava.bindClass("android.content.Intent")
local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
local Looper = luajava.bindClass("android.os.Looper")
local Handler = luajava.bindClass("android.os.Handler")
local activity = this
local handler = Handler(Looper.getMainLooper())
local vibrator = activity.getSystemService("vibrator")
local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

local function startVoiceRecognition(activity)
  local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

  handler.postDelayed(function()
    vibrator.vibrate(50)
  end, 350)

  local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
    onResults = function(params)
      local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
      local text = results.get(0)

      if text and text ~= "" then


        if text:lower() == "توقف" then
          this.postSpeak(200, "تم إيقافُ البحث.")
          return
         elseif text:lower() == "تحديث المفتاح" then
          updateApiKey()
          return
         elseif text:lower() == "جي بي تي" then
          dofile(dir.. "ChatGPT.lua")
          return
         elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
          local function checkSpeakingStatus()
            if not service.isSpeaking() then
              quickAssist()
             else
              handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
            end
          end
          handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
          return
         elseif text:lower() == "تحديث المفتاح" then
          updateApiKey()
          return
         elseif text:lower() == "الاوامر الرئيسيه" then
          dofile(dir.. "MainVoiceCommands.lua")
          return
         elseif text:lower() == "مساعد الهاتف" then
          require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
          service.click({{"<#com.google.android.googlequicksearchbox:id/assistant_robin_floaty_single_line_query>20$1500","%dictAr",}})
          return
         elseif text:lower() == "وصف الشاشه" or text:lower() == "مساعد شاشه الهاتف" then
          require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
          service.click({{"#com.google.android.googlequicksearchbox:id/assistant_robin_screen_context_default_chip>20$1500","%Retour$1000","%dictAr",}})
          return
         elseif text == "الاملاء بالعربيه" then
          dictAr()
          return



         elseif text == "تسجيل الدخول" then
          service.click({{"<#password#1", "%pastePasswordBaridiMob", "#button",}})
          return

         elseif text == "التحويلات" then
          service.click({{"التحويلات|Transfers|Virements","كل انواع التعاملات|Other|Tous types de transactions>50","نحو حساب اخر*|To another account*|Virement Vers autre compte CCP*>50","مصدر التحويل*|From*|Source du virement*>60","*00799999*>50","#edit_value","%Dernier élément",}})
          return
         elseif text == "الاملاء" then
          dictAr()
          return

         elseif text == "فليكسي موبيليس" then
          service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Recharge mobile|شبكات الهاتف النقال>50","Mobilis>50","Source de l’opération*|مصدر العملية*|Source of payment>50","<Débit|الحساب المدين|Debit$100","%éléments suivants$200","%Cliquez","#edit_value_phone$200","%Dernier élément",}})
          return
         elseif text == "فليكسي جيزي" then
          service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Recharge mobile|شبكات الهاتف النقال>50","Djezzy>50","Source de l’opération*|مصدر العملية*|Source of payment>50","<Débit|الحساب المدين|Debit$100","%éléments suivants$200","%Cliquez","#edit_value_phone$200","%Dernier élément",}})
          return
         elseif text == "فليكسي نجمه" then
          service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Recharge mobile|شبكات الهاتف النقال>50","Ooredoo>50","Source de l’opération*|مصدر العملية*|Source of payment>50","<Débit|الحساب المدين|Debit$100","%éléments suivants$200","%Cliquez","#edit_value_phone$200","%Dernier élément",}})
          return


         elseif text:lower() == "الجزائريه للمياه" then
          service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","ADE|الجزائرية للمياه$100","#edit_value>50",}})
          return
         elseif text:lower() == "الجزائريه للمياه الجديده" then
          service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","SEAAL|سيال>50$100","#edit_value>50",}})
          return
         elseif text:lower() == "اتصالات الجزائر" then
          service.click({{"Paiements|Payments|المدفوعات","Tous types de transactions|كل انواع التعاملات|Other>50","Algérie Télécom|اتصالات الجزائر>50",}})
          return

         elseif text == "النماذج" then
          service.click({{"فتح القائمة|Ouvrir le menu|Open menu$100","النماذج|Modèles|Templates>10$100","<#cv#1>50",}})
          return
         elseif text == "تاكيد العمليات" then
          service.click({{"#continue_button","#text_get_code>30","#confirmation_code_otp>10","#android:id/icon1>30","#android:id/content>50","#confirm_button",}})
          return


         elseif text == "تحديث كلمه المرور" then
          updatePasswordBaridiMob()
          return
         elseif text:lower() == "المساعده العامه" then
          dofile(dir.. "help.lua")
          return
         elseif text:lower() == "المساعده" then

          local helpText = [[
توقف
تحديث المفتاح
المساعد السريع
مساعد الهاتف
وصف الشاشة، أو مساعد شاشة الهاتف
جي بي تي 
الأوامر الرئيسية
الإملاء بالعربية
تسجيل الدخول
التحويلات
الإملاء
فليكسي موبيليس
فليكسي جيزي
فليكسي نجمة
الجزائرية للمياه
الجزائرية للمياه الجديدة
اتصالات الجزائر
النماذج
تحديث كلمة المرور
المساعدة
المساعَدة العامة.
            ]]
          for line in helpText:gmatch("[^\r\n]+") do
            print(line)
          end
          return

         else
          this.postSpeak(200, "لا توجد خدمة متطابقة.")
        end
      end
    end,
    onError = function(error)
      this.postSpeak(200, "لم يتم التقاط أي نص.")
    end,
  })

  recognizer.setRecognitionListener(recognitionListener)
  recognizer.startListening(intent)
end

service.speak("BaridiMob")
local function checkSpeakingStatus()
  if not service.isSpeaking() then
    startVoiceRecognition(activity)
   else
    handler.postDelayed(checkSpeakingStatus, 500)
  end
end
handler.postDelayed(checkSpeakingStatus, 500)