require "import"

dofile(dir3.. "displayContacts.lua")
dofile(dir3.. "viewRecentCallsAndDial.lua")
dofile(dir3.. "getAllCallLogs.lua")
dofile(dir3.. "phoneServices.lua")

dofile(dir3.. "manageTasks.lua")
if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          local lowerText = text:lower()
          if text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
         elseif text:lower() == "اضافات المطور" then
          require 'import' import "android.content.*" i= Intent() .setComponent(ComponentName( "com.nirenr.talkman", "com.nirenr.talkman.DownloadActivity")) this.startActivity(i)
          service.click({{"plugins|الإضافات|Extensions>10$100","الكل|ALL|Plus d'options>60$200",{{"Tout$400","%输入/Farouq_fr"},{"<بحث|Enter keyword$100","%输入/Farouq_fr",}},}})
          return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "جي بي تي" then
            dofile(dir.. "ChatGPT.lua")
            return
           elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "الاوامر الرئيسيه" then
            dofile(dir.. "MainVoiceCommands.lua")
            return
           elseif text:lower() == "مساعد الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"<#com.google.android.googlequicksearchbox:id/assistant_robin_floaty_single_line_query>20$1500","%dictAr",}})
            return
           elseif text:lower() == "وصف الشاشه" or text:lower() == "مساعد شاشه الهاتف" then
            require 'import' import "android.content.Intent" i = Intent(Intent.ACTION_VOICE_COMMAND) this.startActivity(i)
            service.click({{"#com.google.android.googlequicksearchbox:id/assistant_robin_screen_context_default_chip>20$1500","%Retour$1000","%dictAr",}})
            return
           elseif text == "الاملاء بالعربيه" then
            dictAr()
            return
           elseif text == "تعديل القاموس" then
            dofile(dir.. "dictionary.lua")
            return
           elseif text:lower() == "الباحث القراني" or text:lower() == "البحث في القران" then
            dofile(dir.. "searchQuran.lua")
            return
         elseif text:lower() == "عدم اغلاق الشاشه" or text:lower() == "ابقاء الشاشه مفتوحه" then
          dofile(dir3.. "keepScreenOnToggle.lua")
          return


           elseif text == "الصلاه القادمه" then
            dofile(dir3.. "nextPrayerSpeak.lua")
            return
           elseif text == "المساجد القريبه" then
            dofile(dir3.. "openNearbyMosques.lua")
            return
           elseif text:lower() == "الموقع الحالي" or text:lower() == "اين انا" then
            dofile(dir3.. "currentLocation.lua")
            return
           elseif text:lower() == "حاله الطقس" or text:lower() == "حاله الجو" then
            require 'import' import "android.content.*" i= Intent() .setComponent(ComponentName("com.google.android.googlequicksearchbox", "com.google.android.apps.search.weather.WeatherExportedActivity")) this.startActivity(i)
            service.click({{"<الأحوال الجوية الحالية|Conditions actuelles>30$1000", "%Lire l'écran complet",}})
            return
           elseif text:lower() == "الحاسبه" then
            dofile(dir3.. "Calculator.lua")
            return
           elseif text == "البحث في التطبيقات" then
            dofile(dir3.. "searchSpecificService.lua")
            return

           elseif text == "اسم جديد" then
            dofile(dir3.. "addNiewContact.lua")
            return
           elseif text == "البحث عن اسم" then
            this.postSpeak(200, "إِبْحَثْ في جهاتِ الإتصال")
            task(1800, function() dofile(dir3.. "searchContactsAr.lua") end)
            return
           elseif text == "جهات الاتصال" then
            displayContacts(contactsList)
            return
           elseif text:lower() == "المفضله" or text:lower() == "الاسماء المفضله" then
            if service.click({{"SHOW FAVORITES$500","<#text1#1",}})
             elseif service.click({{"SHOW ALL CONTACTS$100", "SHOW FAVORITES$500", "<#text1#1",}})
             else
              displayContacts() service.click({{"SHOW FAVORITES>10$500","<#text1#1",}})
            end
            return




           elseif text == "سجل المكالمات" then
            getAllCallLogs()
            return
           elseif text == "الاخيره" then
            getLastCallLog(contactsList)
            return
           elseif text:lower() == "ما قبل الاخيره" then
            getSecondLastCallLog(contactsList)
            return
           elseif text:lower() == "الفائته الاخيره" then
            getLastMissedCallLog(contactsList)
            return
           elseif text:lower() == "الفائته ما قبل الاخيره" then
            getSecondLastMissedCallLog(contactsList)
            return
           elseif text:lower() == "المرفوضه الاخيره" then
            getLastRejectedCallLog(contactsList)
            return
           elseif text:lower() == "المرفوضه ما قبل الاخيره" then
            getSecondLastRejectedCallLog(contactsList)
            return
           elseif text:lower() == "الوارده الاخيره" then
            getLastIncomingCallLog(contactsList)
            return
           elseif text:lower() == "الوارده ما قبل الاخيره" then
            getSecondLastIncomingCallLog(contactsList)
            return
           elseif text:lower() == "الصادره الاخيره" then
            getLastOutgoingCallLog(contactsList)
            return
           elseif text:lower() == "الصادره ما قبل الاخيره" then
            getSecondLastOutgoingCallLog(contactsList)
            return
           elseif text:lower() == "الرقم الاخير" then
            getLastUnnamedCallLog(contactsList)
            return
           elseif text:lower() == "الرقم ما قبل الاخير" then
            getSecondLastUnnamedCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالاخيره" then
            callLastCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بما قبل الاخيره" then
            callSecondLastCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالفائته الاخيره" then
            callLastMissedCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالفائته ما قبل الاخيره" then
            callSecondLastMissedCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالمرفوضه الاخيره" then
            callLastRejectedCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالمرفوضه ما قبل الاخيره" then
            callSecondLastRejectedCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالوارده الاخيره" then
            callLastIncomingCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالوارده ما قبل الاخيره" then
            callSecondLastIncomingCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالصادره الاخيره" then
            callLastOutgoingCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالصادره ما قبل الاخيره" then
            callSecondLastOutgoingCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالرقم الاخير" then
            callLastUnnamedCallLog(contactsList)
            return
           elseif text:lower() == "الاتصال بالرقم ما قبل الاخير" then
            callSecondLastUnnamedCallLog(contactsList)
            return





           elseif lowerText:find("تفضيل") then
            local sanitizedText = lowerText
            :gsub("star", "*")
            :gsub("hash", "#")
            :gsub("شباك", "#")
            :gsub("فاصله", ",")
            :gsub("فاصله منقوطه", ";")
            :gsub("زائد", "+")
            :gsub("صفر", "0")
            :gsub("واحد", "1")
            :gsub("اثنان", "2")
            :gsub("ثلاثه", "3")
            :gsub("اربعه", "4")
            :gsub("خمسه", "5")
            :gsub("سته", "6")
            :gsub("سبعه", "7")
            :gsub("ثمانيه", "8")
            :gsub("تسعه", "9")
            local number = sanitizedText:match("تفضيل%s*([%d%*%#%s]+)")
            if number then
              number = number:gsub("%s+", "")
              service.addFavorites(number)
              this.postSpeak(200, "تمَّ تفْضيل: " .. number)
              return
             else
              this.postSpeak(200, "يُرجَى نُطْقُ الرَّقْمِ  بعدَ كلمة 'تفضيل.")
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity)
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000)
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500)
            end
           elseif lowerText:find("نسخ") then
            local sanitizedText = lowerText
            :gsub("star", "*")
            :gsub("hash", "#")
            :gsub("شباك", "#")
            :gsub("فاصله", ",")
            :gsub("فاصله منقوطه", ";")
            :gsub("زائد", "+")
            :gsub("صفر", "0")
            :gsub("واحد", "1")
            :gsub("اثنان", "2")
            :gsub("ثلاثه", "3")
            :gsub("اربعه", "4")
            :gsub("خمسه", "5")
            :gsub("سته", "6")
            :gsub("سبعه", "7")
            :gsub("ثمانيه", "8")
            :gsub("تسعه", "9")
            local number = sanitizedText:match("نسخ%s*([%d%*%#%s]+)")
            if number then
              number = number:gsub("%s+", "")
              service.copy(number)
              this.postSpeak(200, "تمَّ نسخ: " .. number)
              return
             else
              this.postSpeak(200, "يُرجَى نُطْقُ الرَّقْمِ  بعدَ كلمة 'نسخ.")
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity)
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000)
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500)
            end
           elseif lowerText:find("اضافه") then
            local sanitizedText = lowerText
            :gsub("star", "*")
            :gsub("hash", "#")
            :gsub("شباك", "#")
            :gsub("فاصله", ",")
            :gsub("فاصله منقوطه", ";")
            :gsub("زائد", "+")
            :gsub("صفر", "0")
            :gsub("واحد", "1")
            :gsub("اثنان", "2")
            :gsub("ثلاثه", "3")
            :gsub("اربعه", "4")
            :gsub("خمسه", "5")
            :gsub("سته", "6")
            :gsub("سبعه", "7")
            :gsub("ثمانيه", "8")
            :gsub("تسعه", "9")
            local number = sanitizedText:match("اضافه%s*([%d%*%#%s]+)")
            if number then
              number = number:gsub("%s+", "")
              intent = Intent(ContactsContract.Intents.Insert.ACTION);
              intent.setType(ContactsContract.RawContacts.CONTENT_TYPE);
              intent.putExtra(ContactsContract.Intents.Insert.PHONE, number);
              this.startActivity(intent);
              return
             else
              this.postSpeak(200, "يُرجَى نُطْقُ الرَّقْمِ  بعدَ كلمة 'إضافة.")
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity)
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000)
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500)
            end



           elseif lowerText:find("اتصال") then
            local sanitizedText = lowerText
            :gsub("star", "*")
            :gsub("hash", "#")
            :gsub("شباك", "#")
            :gsub("فاصله", ",")
            :gsub("فاصله منقوطه", ";")
            :gsub("زائد", "+")
            :gsub("صفر", "0")
            :gsub("واحد", "1")
            :gsub("اثنان", "2")
            :gsub("ثلاثه", "3")
            :gsub("اربعه", "4")
            :gsub("خمسه", "5")
            :gsub("سته", "6")
            :gsub("سبعه", "7")
            :gsub("ثمانيه", "8")
            :gsub("تسعه", "9")
            local number = sanitizedText:match("اتصال%s*([%d%*%#%s]+)")
            if number then
              number = number:gsub("%s+", "")
              local i = Intent(Intent.ACTION_CALL, Uri.parse("tel:" .. Uri.encode(number)))
              this.startActivity(i)
             else
              this.postSpeak(200, "يُرجَى نُطْقُ الرَّقْمِ  بعدَ كلمة 'اتصال'.")
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity)
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000)
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500)
            end
           elseif lowerText:find("رساله") then
            local sanitizedText = lowerText
            :gsub("star", "*")
            :gsub("hash", "#")
            :gsub("شباك", "#")
            :gsub("فاصله", ",")
            :gsub("فاصله منقوطه", ";")
            :gsub("زائد", "+")
            :gsub("صفر", "0")
            :gsub("واحد", "1")
            :gsub("اثنان", "2")
            :gsub("ثلاثه", "3")
            :gsub("اربعه", "4")
            :gsub("خمسه", "5")
            :gsub("سته", "6")
            :gsub("سبعه", "7")
            :gsub("ثمانيه", "8")
            :gsub("تسعه", "9")
            local number = sanitizedText:match("رساله%s*([%d%*%#%s]+)")
            if number then
              number = number:gsub("%s+", "")
              local smsIntent = Intent(Intent.ACTION_SENDTO, Uri.parse("smsto:" .. Uri.encode(number)))
              smsIntent.putExtra("sms_body", "السلام عليكم\n")
              this.startActivity(smsIntent)
             else
              this.postSpeak(200, "يُرجَى نُطْقُ الرَّقْمِ  بعدَ كلمة 'رسالة'.")
              local function checkSpeakingStatus()
                if not service.isSpeaking() then
                  startVoiceRecognition(activity)
                 else
                  handler.postDelayed(checkSpeakingStatus, 1000)
                end
              end
              handler.postDelayed(checkSpeakingStatus, 1500)
            end






           elseif text:lower() == "رصيدي" then
            myBalance()
            return
           elseif text:lower() == "اظهار رقمي" then
            showNumber()
            return
           elseif text:lower() == "اخفاء رقمي" then
            hideNumber()
            return
           elseif text:lower() == "المكالمه في الانتظار" then
            enableCallWaiting()
            return
           elseif text:lower() == "الرقم مشغول" then
            disableCallWaiting()
            return
           elseif text:lower() == "اسم المتصل" then
            useSpeakCallPhone()
            return
           elseif text:lower() == "مده المكالمه" then
            useSpeakCallTime()
            return
           elseif text:lower() == "وضع الهاتف" then
            phoneMode()
            return






           elseif text:lower() == "رصيدي" then
            myBalance()
            return
           elseif text:lower() == "اظهار رقمي" then
            showNumber()
            return
           elseif text:lower() == "اخفاء رقمي" then
            hideNumber()
            return
           elseif text:lower() == "المكالمه في الانتظار" then
            enableCallWaiting()
            return
           elseif text:lower() == "الرقم مشغول" then
            disableCallWaiting()
            return
           elseif text:lower() == "اسم المتصل" then
            useSpeakCallPhone()
            return
           elseif text:lower() == "مده المكالمه" then
            useSpeakCallTime()
            return
           elseif text:lower() == "وضع الهاتف" then
            phoneMode()
            return




           elseif text == "معلومات الذاكره" then
            dofile(dir3.. "Memory Information.lua")
            return
           elseif text == "الاتجاهات والقبله" then
            dofile(dir3.. "Directions and Qibla..lua")
            return


           elseif text:lower() == "مهمه جديده" then
            addNewTask()
            return
           elseif text:lower() == "المهام اليوميه" or text:lower() == "المهمات اليوميه" then
            showDailyTasks()
            return
           elseif text:lower() == "المهام الاسبوعيه" or text:lower() == "المهمات الاسبوعيه" then
            showWeeklyTasks()
            return
           elseif text:lower() == "المهام الشهريه" or text:lower() == "المهمات الشهريه" then
            showMonthlyTasks()
            return
           elseif text:lower() == "المهام السنويه" or text:lower() == "المهمات السنويه" then
            showYearlyTasks()
            return
           elseif text:lower() == "جميع المهام" or text:lower() == "جميع المهمات" then
            showAllTasks()
            return
           elseif text:lower() == "حذف جميع المهام" then
            deleteAllTasks()
            return


           elseif text:lower() == "ملاحظه جديده" then
            dofile(dir.. "newCloudNote.lua")
            return
           elseif text:lower() == "ملف جديد" then
            dofile(dir.. "newFile.lua")
            return

           elseif text:lower() == "المساعده الخاصه بالمكالمات" then
            dofile(dir3.. "helpPhoneServices.lua")
            return
           elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then

            local helpText = [[
توقف
إضافات المطور
تحديث المفتاح
المساعد السريع
مساعد الهاتف
وصف الشاشة، أو مساعد شاشة الهاتف
جي بي تي 
الأوامر الرئيسية
الإملاء بالعربية
تعديل القاموس
الباحث القرآني أو البحث في القرآن
عدم إغلاق الشاشة أو إبقاء الشاشة مفتوحة.
الصلاة القادمة
المساجد القريبة
الاتجاهات والقبلة
أين أنا، أو الموقع الحالي
حالة الطقس أو حالة الجو
الحاسبة
معلومات الذاكرة
البحث في التطبيقات
وهذه هي التطبيقات التي يمكن البحث داخلها.
يوتيوب عربي
يوتيوب فرنسي
يوتيوب انجليزي
فيسبوك عربي
فيسبوك فرنسي
فيسبوك انجليزي
تطبيق عربي
تطبيق فرنسي
تطبيق انجليزي
جوجل عربي
جوجل فرنسي
جوجل انجليزي
خرائط عربي
خرائط فرنسي
خرائط انجليزي

أوامر جهات الاتصال وسجل المكالمات وخدمات المكالمات
اسم جديد
البحث عن اسم
جهات الاتصال
المفضلة, أو الأسماء المفضلة
سجل المكالمات
الأخيرة
ما قبل الأخيرة
الفائتة الأخيرة
الفائتة ما قبل الأخيرة
المرفوضة الأخيرة
المرفوضة ما قبل الأخيرة
الواردة الأخيرة
الواردة ما قبل الأخيرة
الصادرة الأخيرة
الصادرة ما قبل الأخيرة
الرقم الأخير
الرقم ما قبل الأخير
الاتصال بالأخيرة
الاتصال بما قبل الأخيرة
الاتصال بالفائتة الأخيرة
الاتصال بالفائتة ما قبل الأخيرة
الاتصال بالمرفوضة الأخيرة
الاتصال بالمرفوضة ما قبل الأخيرة
الاتصال بالواردة الأخيرة
الاتصال بالواردة ما قبل الأخيرة
الاتصال بالصادرة الأخيرة
الاتصال بالصادرة ما قبل الأخيرة
الاتصال بالرقم الأخير
الاتصال بالرقم ما قبل الأخير
تفضيل
نسخ
إضافة
اتصال
رسالة
رصيدي
إظهار رقمي
إخفاء رقمي
المكالمة في الانتظار
الرقم مشغول
اسم المتصل
مدة المكالمة
وضع الهاتف

أوامر إدارة المهام
مهمة جديدة
المهام اليومية أو المهمات اليومية.
المهام الأسبوعية أو المهمات الأسبوعية
المهام الشهرية أو المهمات الشهرية
المهام السنوية أو المهمات الثانوية.
جميع المهام
حذف جميع المهام
ملاحظة جديدة
ملف جديد.
المساعَدة العامة.
المساعدة
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return
           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("launcher")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end