require "import"
import "android.content.Context"
import "android.content.ClipData"
import "android.content.ClipboardManager"
import "android.net.Uri"
import "android.text.Html"
import "com.androlua.Http"
import "java.util.Locale"
import "android.os.Handler"
import "android.os.Looper"
import "android.os.Vibrator"
import "cjson"
import "com.androlua.LuaDialog"
import "io"
import "android.widget.*"
import "android.view.*"
import "android.graphics.*"
import "android.app.*"
import "android.util.*"
import "android.text.TextWatcher"
import "com.androlua.*"
import "android.content.Intent"
import "java.io.File"
import "java.io.FileOutputStream"
import "android.view.View$OnLongClickListener"

local file_path = "/storage/emulated/0/Documents/comfortableDictation/replacements.txt"

getGeminiApiKey = function()
  local file_path = "/storage/emulated/0/Documents/comfortableDictation/gemini.txt"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    file_read:close()
    if content ~= "" then
      return content
     else
      LuaDialog()
      .setTitle("لا يوجد محتوى")
      .setMessage("الملف موجود لكن لا يحتوي على مفتاح.")
      .setPositiveButton("تحديث مفتاح Gemini", function() updateApiKey()end)
      .setNegativeButton("المزيد", function()
        LuaDialog()
        .setTitle("إختر ما يناسبك")
        .setMessage("يمكنك استخدام المفتاح العام، وهذا المفتاح يستخدمه الكثيرون فهو معرض للتوقف في أي لحظة.\nكما يمكنك الحصول على مفتاح خاص بك من الموقع عبر الزر أدناه")
        .setPositiveButton("استخدام المفتاح العام", function() updateApiKey()
          updateApiKey() task(1600, function()
          service.click({{"%输入/AIzaSyA70wke7JY_W2DQsv87Y8sCBpQkcK7jCi8", "#button1$400","#button1",}}) end)
        end)
        .setNegativeButton("الحصول على مفتاح جديد", function()
          local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)
        end)
        .show()
      end)
      .show()
    end
   else
    LuaDialog()
    .setTitle("خطأ في القراءة")
    .setMessage("تعذر فتح الملف لقراءة المفتاح.")
    .setPositiveButton("تحديث مفتاح Gemini", function() updateApiKey()end)
    .setNegativeButton("المزيد", function()
      LuaDialog()
      .setTitle("إختر ما يناسبك")
      .setMessage("يمكنك استخدام المفتاح العام، وهذا المفتاح يستخدمه الكثيرون فهو معرض للتوقف في أي لحظة.\nكما يمكنك الحصول على مفتاح خاص بك من الموقع عبر الزر أدناه")
      .setPositiveButton("استخدام المفتاح العام", function() updateApiKey()
        updateApiKey() task(1600, function()
        service.click({{"%输入/AIzaSyA70wke7JY_W2DQsv87Y8sCBpQkcK7jCi8", "#button1$400","#button1",}}) end)
      end)
      .setNegativeButton("الحصول على مفتاح جديد", function()
        local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)
      end)
      .show()
    end)
    .show()
  end
  return nil
end
local geminiApiKey = getGeminiApiKey()
local geminiApiEndpoint = "https://generativelanguage.googleapis.com/v1beta/models/gemini-2.0-flash:generateContent"




function clearDictionaryContent()
  local filePath = "/storage/emulated/0/Documents/comfortableDictation/replacements.txt"
  local file = File(filePath)

  if file.exists() then
    local dialog = LuaDialog(this)
    dialog.setTitle("تنبيه")
    dialog.setMessage("هل أنت متأكد أنك تريد حذف كل المحتوى داخل الملف؟")
    dialog.setPositiveButton("نعم", function()
      local fos = FileOutputStream(file, false)
      fos.close()
service.postSpeak(400,"تم حذف محتوى الملف بنجاح.")
service.postClick(200,{{"%Retour"}})
    end)
    dialog.setNegativeButton("إلغاء", function()
service.postSpeak(400,"تم إلغاء العملية.")
    end)
    dialog.show()
  else
service.postSpeak(400,"الملف غير موجود.")
  end
end




function sherDictionary()
      local filePath = "/storage/emulated/0/Documents/comfortableDictation/replacements.txt"
      local file = File(filePath)
      if file.exists() then
        local uri = this.getUriForFile(file)
        local intent = Intent(Intent.ACTION_SEND)
        intent.setType("*/*")
        intent.putExtra(Intent.EXTRA_STREAM, uri)
        intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
        local chooser = Intent.createChooser(intent, "مشاركة الملف مع...")
        chooser.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
        this.startActivity(chooser)
      else
        print("الملف غير موجود.")
      end

end





function dictArRaw()
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
  local vibrator = activity.getSystemService("vibrator")

  local aiResponseReceived = false

  local function urlEncode(text)
    text = tostring(text)
    text = text:gsub("\n", "\r\n")
    text = text:gsub("([^%w %-%_%.%~])", function(c)
      return string.format("%%%02X", string.byte(c))
    end)
    text = text:gsub(" ", "+")
    return text
  end

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onReadyForSpeech = function(params) end,

      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        handler.postDelayed(function()
          vibrator.vibrate(100)
        end, 350)

        if text and text ~= "" then
          aiResponseReceived = false

          local inputText = "Only correct the grammatical and spelling errors in the following text. Keep the original language unchanged. If there are some English or French words written in Arabic, write them in their original language (English or French). Also, if any Latin words are found written in Arabic, convert them to Latin even if they are in the middle of Arabic text. Do not add any greetings, responses, or explanations. Do not respond to welcome texts such as greetings, especially if the text contains only one or two words. If the text contains nothing at all, do not respond at all. Do not consider the text a question, and therefore do not respond to it; just correct it only.  Return only the corrected text: " .. text

          local requestBody = cjson.encode({
            contents = {
              {
                parts = {
                  { text = inputText }
                }
              }
            }
          })

          local headers = {
            ["Content-Type"] = "application/json",
            ["x-goog-api-key"] = geminiApiKey
          }

          Http.post(geminiApiEndpoint, requestBody, headers, function(status, data)
            local node = service.getEditText()

            if status == 200 then
              local response = cjson.decode(data)
              if response and response.candidates and response.candidates[1] and
                response.candidates[1].content and response.candidates[1].content.parts and
                response.candidates[1].content.parts[1] and
                response.candidates[1].content.parts[1].text then

                local cleanedData = response.candidates[1].content.parts[1].text
                service.insertText(node, cleanedData)
                this.speak(cleanedData)
               else
                this.postSpeak(500, "تنسيق استجابة Gemini 2.0 Flash غير متوقع.")
                service.insertText(node, text .. " \n")
                print("Gemini API Response Data:", data)
              end
             else
              this.postSpeak(500, "حدث خطأ في الاتصال بـ Gemini 2.0 Flash API: " .. status)
              service.insertText(node, text .. " \n")
              print("Gemini API Error Status:", status)
              print("Gemini API Error Data:", data)
            end

            aiResponseReceived = true
          end)
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  startVoiceRecognition(activity)
end





function loadData()
  local list, raw = {}, {}
  local fr = io.open(file_path, "r")
  if fr then
    for line in fr:lines() do
      local from, to = line:match("^(.-)%s*=>%s*(.-)%s*$")
      if from and to then
        table.insert(list, {from, to})
        table.insert(raw, line)
      end
    end
    fr:close()
  end
  return list, raw
end
function showReplacements()
local dataList, rawLines = loadData()
local dlg = LuaDialog(this)

local layout = {
  LinearLayout,
  orientation = "vertical",
  backgroundColor = 0xFF000000,

  {
    TextView,
    id = "headerText",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    text = "قاموس الإملاء",
    textSize = "20sp",
    gravity = "center",
    textColor = 0xFFFFFFFF,
    backgroundColor = 0xFF000000,
    onClick = function(view)
sherDictionary()
      dlg.dismiss()
    end
  },

  {
    EditText,
    id = "searchText",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "ابحث هنا...",
    hintTextColor = 0xFFAAAAAA,
    backgroundColor = 0xFF0D47A1,
    textColor = 0xFFFFFFFF,
    padding = "8dp",
    singleLine = true
  },

  {
    ListView,
    id = "listView",
    layout_width = "match_parent",
    layout_height = "0dp",
    layout_weight = 1,
    backgroundColor = 0xFF000000
  },

  {
    LinearLayout,
    orientation = "horizontal",
    layout_width = "match_parent",
    {
      Button,
      layout_width = "0dp",
      layout_weight = 1,
      text = "إضافة استبدال جديد",
      backgroundColor = 0xFF006400,
      textColor = 0xFFFFFFFF,
      onClick = function()
        dlg.dismiss()
        addNewReplacement()
      end
    },
    {
      Space,
      layout_width = "8dp"
    },
    {
      Button,
      layout_width = "0dp",
      layout_weight = 1,
      text = "خروج",
      backgroundColor = 0xFF8B0000,
      textColor = 0xFFFFFFFF,
      onClick = function()
        dlg.dismiss()
      end
    }
  }
}





  local views = {}
  dlg.setView(loadlayout(layout, views))

-- تعيين الضغط المطول بعد تحميل الواجهة
views.headerText.setOnLongClickListener{
  onLongClick = function(v)
clearDictionaryContent()
    return true
  end
}

  -- تعيين OnLongClickListener لمربع البحث هنا
  views.searchText.setOnLongClickListener(View.OnLongClickListener{
    onLongClick = function(view)
dictArRaw()
      -- هنا يمكنك إضافة الـ Thing التي تريد تنفيذها عند الضغط المطول
      return true -- return true to consume the long click event
    end
  })

  local initialDisplayList = {}
  for _, pair in ipairs(dataList) do
    table.insert(initialDisplayList, pair[1] .. " => " .. pair[2])
  end

  local adapter = ArrayAdapter(this, android.R.layout.simple_list_item_1, initialDisplayList)
  views.listView.setAdapter(adapter)

  views.searchText.addTextChangedListener(TextWatcher{
    onTextChanged = function(charSequence, start, before, count)
      adapter.getFilter().filter(charSequence)
    end,
    beforeTextChanged = function(charSequence, start, count, after)
      -- لا يوجد شيء هنا
    end,
    afterTextChanged = function(editable)
      -- لا يوجد شيء هنا
    end
  })

  views.listView.setOnItemClickListener(AdapterView.OnItemClickListener{
    onItemClick = function(parent, view, position, id)
      local selectedItemText = tostring(adapter.getItem(position))
      local originalPosition = -1

      for i, line in ipairs(rawLines) do
        local from, to = line:match("^(.-)%s*=>%s*(.-)%s*$")
        if (from .. " => " .. to) == selectedItemText then
          originalPosition = i
          break
        end
      end

      if originalPosition == -1 then
        service.postSpeak(200, "حدث خطأ: لم يتم العثور على العنصر الأصلي.")
        return
      end

      local oldFrom, oldTo = dataList[originalPosition][1], dataList[originalPosition][2]

      local editViews = {}
      local editDlg

      local layout = {
        LinearLayout,
        orientation = "vertical",
        padding = "16dp",
        backgroundColor = 0xFF000000,
        {
          EditText,
          id = "fromInput",
          hint = "النص الأصلي",
          text = oldFrom,
          backgroundColor = 0xFF0D47A1,
          textColor = 0xFFFFFFFF,
          layout_width = "match_parent",
          singleLine = true
          -- تم إزالة onLongClick من هنا
        },
        {
          EditText,
          id = "toInput",
          hint = "النص المستبدل",
          text = oldTo,
          backgroundColor = 0xFF0D47A1,
          textColor = 0xFFFFFFFF,
          layout_width = "match_parent",
          singleLine = true
          -- تم إزالة onLongClick من هنا
        },
        {
          LinearLayout,
          orientation = "horizontal",
          layout_width = "match_parent",
{
  Button,
  text = "حفظ التعديل",
  backgroundColor = 0xFF004D00,
  textColor = 0xFFFFFFFF,
  layout_weight = 1,
  onClick = function()
    local fromText = tostring(editViews.fromInput.getText()):match("^%s*(.-)%s*$")
    local toText = tostring(editViews.toInput.getText()):match("^%s*(.-)%s*$")

    if fromText == "" or toText == "" then
      service.postSpeak(200,"الرجاء إدخال كِلا الحقلين")
      return
    end

    local newLine = fromText .. " => " .. toText

    rawLines[originalPosition] = newLine

    local fw = io.open(file_path, "w")
    for _, line in ipairs(rawLines) do
      fw:write(line .. "\n")
    end
    fw:close()

    service.postSpeak(200,"تم التعديل")
    dlg.dismiss()
    showReplacements()
    if editDlg then
      editDlg.dismiss()
    end
  end
},
          {
            Space,
            layout_width = "8dp"
          },
          {
            Button,
            text = "إلغاء",
            backgroundColor = 0xFF8B0000,
            textColor = 0xFFFFFFFF,
            layout_weight = 1,
            onClick = function()
              if editDlg then
                editDlg.dismiss()
              end
            end
          }
        }
      }

      editDlg = LuaDialog(this)
      editDlg.setView(loadlayout(layout, editViews))

      -- تعيين OnLongClickListener لمربع التحرير "من" هنا
      editViews.fromInput.setOnLongClickListener(View.OnLongClickListener{
        onLongClick = function(view)
          dictArRaw()
          service.postSpeak(200, "ضغط مطول على حقل من") -- مثال: إضافة نطق
          -- هنا يمكنك إضافة الـ Thing التي تريد تنفيذها عند الضغط المطول
          return true -- return true to consume the long click event
        end
      })

      -- تعيين OnLongClickListener لمربع التحرير "إلى" هنا
      editViews.toInput.setOnLongClickListener(View.OnLongClickListener{
        onLongClick = function(view)
          dictArRaw()
          -- هنا يمكنك إضافة الـ Thing التي تريد تنفيذها عند الضغط المطول
          return true -- return true to consume the long click event
        end
      })

      editDlg.show()
    end
  })

  views.listView.setOnItemLongClickListener(AdapterView.OnItemLongClickListener{
    onItemLongClick = function(parent, view, position, id)
      local popup = PopupMenu(this, view)
      local menu = popup.getMenu()

      menu.add("حذف الاستبدال")
      menu.add("تحريك للأعلى")
      menu.add("تحريك للأسفل")
      menu.add("إدراج")
menu.add("تكرار")
menu.add("تكرار مزدوج")

      popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
        onMenuItemClick = function(item)
          local title = tostring(item.getTitle())

          local selectedItemText = tostring(adapter.getItem(position))
          local originalPosition = -1

          for i, line in ipairs(rawLines) do
            local from, to = line:match("^(.-)%s*=>%s*(.-)%s*$")
            if (from .. " => " .. to) == selectedItemText then
              originalPosition = i
              break
            end
          end

          if originalPosition == -1 then
            service.postSpeak(200, "حدث خطأ: لم يتم العثور على العنصر الأصلي.")
            return true
          end

          if title == "حذف الاستبدال" then
            local confirmDialog = LuaDialog(this)
            confirmDialog.setTitle("تأكيد الحذف")
            confirmDialog.setMessage("هل تريد حذف هذا الاستبدال؟")
            confirmDialog.setPositiveButton("نعم", function()
              table.remove(rawLines, originalPosition)
              local fw = io.open(file_path, "w")
              for _, line in ipairs(rawLines) do
                fw:write(line .. "\n")
              end
              fw:close()
              service.postSpeak(200,"تم الحذف")
              dlg.dismiss()
              showReplacements()
            end)
            confirmDialog.setNegativeButton("إلغاء", function() end)
            confirmDialog.show()

           elseif title == "تحريك للأعلى" then
            if originalPosition > 1 then
              rawLines[originalPosition], rawLines[originalPosition - 1] = rawLines[originalPosition - 1], rawLines[originalPosition]
              local fw = io.open(file_path, "w")
              for _, line in ipairs(rawLines) do
                fw:write(line .. "\n")
              end
              fw:close()
              service.postSpeak(200, "تم تحريك العنصر للأعلى")
              dlg.dismiss()
              showReplacements()
             else
              service.postSpeak(200, "هذا العنصر في الأعلى بالفعل")
            end

           elseif title == "تحريك للأسفل" then
            if originalPosition < #rawLines then
              rawLines[originalPosition], rawLines[originalPosition + 1] = rawLines[originalPosition + 1], rawLines[originalPosition]
              local fw = io.open(file_path, "w")
              for _, line in ipairs(rawLines) do
                fw:write(line .. "\n")
              end
              fw:close()
              service.postSpeak(200, "تم تحريك العنصر للأسفل")
              dlg.dismiss()
              showReplacements()
             else
              service.postSpeak(200, "هذا العنصر في الأسفل بالفعل")
            end

           elseif title == "إدراج" then
            -- نمرر originalPosition إلى الدالة
            insertReplacementAfterPosition(originalPosition)


elseif title == "تكرار" then
-- نفترض أن originalPosition هو رقم السطر الحالي
if originalPosition <= #rawLines then
  table.insert(rawLines, originalPosition + 1, rawLines[originalPosition])
  local fw = io.open(file_path, "w")
  for _, line in ipairs(rawLines) do
    fw:write(line .. "\n")
  end
  fw:close()
  service.postSpeak(200, "تم نسخ العنصر ولصقه تحته")
  dlg.dismiss()
  showReplacements()
else
  service.postSpeak(200, "لا يمكن نسخ هذا العنصر")
end

elseif title == "تكرار مزدوج" then
if originalPosition <= #rawLines then
  local currentLine = rawLines[originalPosition]
  table.insert(rawLines, originalPosition + 1, currentLine)
  table.insert(rawLines, originalPosition + 2, currentLine) -- لاحظ أن هذا يبقى +2 لأن الجدول تغيّر بعد الإدراج الأول
  local fw = io.open(file_path, "w")
  for _, line in ipairs(rawLines) do
    fw:write(line .. "\n")
  end
  fw:close()
  service.postSpeak(200, "تم تكرار العنصر مرتين تحته")
  dlg.dismiss()
  showReplacements()
else
  service.postSpeak(200, "لا يمكن تكرار هذا العنصر")
end
          end

          return true
        end
      })

      popup.show()
      return true
    end
  })

  dlg.show()
end







function addNewReplacement()
  local views = {}
  local dlg = LuaDialog(this)

  local layout = {
    LinearLayout,
    orientation = "vertical",
    padding = "16dp",
    backgroundColor = 0xFF000000,
    {
      EditText,
      id = "fromInput",
      hint = "النص الأصلي",
      backgroundColor = 0xFF0D47A1,
      textColor = 0xFFFFFFFF,
      layout_width = "match_parent",
      singleLine = true
    },
    {
      EditText,
      id = "toInput",
      hint = "النص المستبدل",
      backgroundColor = 0xFF0D47A1,
      textColor = 0xFFFFFFFF,
      layout_width = "match_parent",
      singleLine = true
    },
    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      {
        Button,
        id = "addButton",
        text = "إضافة",
        layout_weight = 1,
        backgroundColor = 0xFF004D00,
        textColor = 0xFFFFFFFF
      },
      {
        Space,
        layout_width = "8dp"
      },
      {
        Button,
        text = "إلغاء",
        layout_weight = 1,
        backgroundColor = 0xFF8B0000,
        textColor = 0xFFFFFFFF,
        onClick = function()
          dlg.dismiss()
        end
      }
    }
  }

  dlg.setView(loadlayout(layout, views))

  views.fromInput.setOnLongClickListener(View.OnLongClickListener{
    onLongClick = function(view)
      dictArRaw()
      return true
    end
  })

  views.toInput.setOnLongClickListener(View.OnLongClickListener{
    onLongClick = function(view)
      dictArRaw()
      return true
    end
  })

  views.addButton.setOnClickListener(View.OnClickListener{
    onClick = function()
      local fromText = tostring(views.fromInput.getText()):match("^%s*(.-)%s*$")
      local toText = tostring(views.toInput.getText()):match("^%s*(.-)%s*$")
      local line = fromText .. " => " .. toText

      if fromText == "" or toText == "" then
        service.postSpeak(200,"الرجاء إدخال كِلا الحقلين")
        return
      end

      local fw = io.open(file_path, "a")
      if fw then
        fw:write(line .. "\n")
        fw:close()
        service.postSpeak(200,"تمت الإضافة")
      end
      dlg.dismiss()
      task(100, function()
        showReplacements()
      end)
    end
  })

  dlg.show()
end








function insertReplacementAfterPosition(originalPosition)
  local views = {}
  local dlg = LuaDialog(this)

  local layout = {
    LinearLayout,
    orientation = "vertical",
    padding = "16dp",
    backgroundColor = 0xFF000000,
    {
      EditText,
      id = "fromInput",
      hint = "النص الأصلي",
      backgroundColor = 0xFF0D47A1,
      textColor = 0xFFFFFFFF,
      layout_width = "match_parent",
      singleLine = true
    },
    {
      EditText,
      id = "toInput",
      hint = "النص المستبدل",
      backgroundColor = 0xFF0D47A1,
      textColor = 0xFFFFFFFF,
      layout_width = "match_parent",
      singleLine = true
    },
    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      {
        Button,
        id = "addButton",
        text = "إضافة",
        layout_weight = 1,
        backgroundColor = 0xFF004D00,
        textColor = 0xFFFFFFFF
      },
      {
        Space,
        layout_width = "8dp"
      },
      {
        Button,
        text = "إلغاء",
        layout_weight = 1,
        backgroundColor = 0xFF8B0000,
        textColor = 0xFFFFFFFF,
        onClick = function()
          dlg.dismiss()
        end
      }
    }
  }

  dlg.setView(loadlayout(layout, views))

  views.fromInput.setOnLongClickListener(View.OnLongClickListener{
    onLongClick = function(view)
      dictArRaw()
      return true
    end
  })

  views.toInput.setOnLongClickListener(View.OnLongClickListener{
    onLongClick = function(view)
      dictArRaw()
      return true
    end
  })

  views.addButton.setOnClickListener(View.OnClickListener{
    onClick = function()
      local fromText = tostring(views.fromInput.getText()):match("^%s*(.-)%s*$")
      local toText = tostring(views.toInput.getText()):match("^%s*(.-)%s*$")
      local line = fromText .. " => " .. toText

      if fromText == "" or toText == "" then
        service.postSpeak(200,"الرجاء إدخال كِلا الحقلين")
        return
      end

      local _, currentRawLines = loadData()
      table.insert(currentRawLines, originalPosition + 1, line)

      local fw = io.open(file_path, "w")
      if fw then
        for _, l in ipairs(currentRawLines) do
          fw:write(l .. "\n")
        end
        fw:close()
        service.postSpeak(200,"تمت الإضافة في الموضع المحدد")
      end
      dlg.dismiss()
      task(100, function()
        showReplacements()
      end)
    end
  })

  dlg.show()
end


showReplacements()