require "import"
import "android.content.Context"
import "android.content.ClipData"
import "android.content.ClipboardManager"
import "android.net.Uri"
import "android.text.Html"
import "com.androlua.Http"
import "java.util.Locale"
import "android.os.Handler"
import "android.os.Looper"
import "android.os.Vibrator"
import "cjson"
import "android.widget.EditText"
import "com.androlua.LuaDialog"
import "io"
import "com.androlua.Http"

getGeminiApiKey = function()
  local file_path = "/storage/emulated/0/Documents/comfortableDictation/gemini.txt"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    file_read:close()
    if content ~= "" then
      return content
     else
      LuaDialog()
      .setTitle("لا يوجد محتوى")
      .setMessage("الملف موجود لكن لا يحتوي على مفتاح.")
      .setPositiveButton("تحديث مفتاح Gemini", function() updateApiKey()end)
      .setNegativeButton("المزيد", function()
        LuaDialog()
        .setTitle("إختر ما يناسبك")
        .setMessage("يمكنك استخدام المفتاح العام، وهذا المفتاح يستخدمه الكثيرون فهو معرض للتوقف في أي لحظة.\nكما يمكنك الحصول على مفتاح خاص بك من الموقع عبر الزر أدناه")
        .setPositiveButton("استخدام المفتاح العام", function() updateApiKey()
          updateApiKey() task(1600, function()
          service.click({{"%输入/AIzaSyA70wke7JY_W2DQsv87Y8sCBpQkcK7jCi8", "#button1$400","#button1",}}) end)
        end)
        .setNegativeButton("الحصول على مفتاح جديد", function()
          local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)
        end)
        .show()
      end)
      .show()
    end
   else
    LuaDialog()
    .setTitle("خطأ في القراءة")
    .setMessage("تعذر فتح الملف لقراءة المفتاح.")
    .setPositiveButton("تحديث مفتاح Gemini", function() updateApiKey()end)
    .setNegativeButton("المزيد", function()
      LuaDialog()
      .setTitle("إختر ما يناسبك")
      .setMessage("يمكنك استخدام المفتاح العام، وهذا المفتاح يستخدمه الكثيرون فهو معرض للتوقف في أي لحظة.\nكما يمكنك الحصول على مفتاح خاص بك من الموقع عبر الزر أدناه")
      .setPositiveButton("استخدام المفتاح العام", function() updateApiKey()
        updateApiKey() task(1600, function()
        service.click({{"%输入/AIzaSyA70wke7JY_W2DQsv87Y8sCBpQkcK7jCi8", "#button1$400","#button1",}}) end)
      end)
      .setNegativeButton("الحصول على مفتاح جديد", function()
        local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)
      end)
      .show()
    end)
    .show()
  end
  return nil
end


function updateApiKey()
  -- التأكد من وجود المجلد والملف
  local file_path = "/storage/emulated/0/Documents/comfortableDictation/gemini.txt"
  io.mkdir("/storage/emulated/0/Documents/")
  io.mkdir("/storage/emulated/0/Documents/comfortableDictation")
  io.open(file_path, "a"):close()

  local dlg = LuaDialog()
  local edit = loadlayout{
    EditText,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "مفتاح Gemini الجديد"
  }
  edit.setBackgroundColor(0xFF00008B)

  -- قراءة المفتاح الحالي (إن وُجد)
  local current_key = "غير معروف"
  local file_read = io.open(file_path, "r")
  if file_read then
    local content = file_read:read("*a"):gsub("\n", "")
    if content ~= "" then
      current_key = content
    end
    file_read:close()
  end

  dlg.setTitle("تحديث مفتاح Gemini")
  dlg.setMessage("المفتاح الحالي:\n" .. current_key)
  dlg.setView(edit)
  edit.setContentDescription("أدخل مفتاح Gemini الجديد هنا، ثم تحقق منه عبر التمرير للأسفل أو للأعلى.")

  dlg.setButton("حفظ", function()
    local new_key = tostring(edit.getText())
    if new_key and new_key ~= "" then
      local f = io.open(file_path, "w")
      if f then
        f:write(new_key .. "\n")
        f:close()

        local successDialog = LuaDialog(service)
        successDialog.setTitle("تم تحديث مفتاح Gemini")
        successDialog.setMessage("تم حفظ المفتاح:\n" .. new_key)
        successDialog.setCancelable(false)
        successDialog.setOnKeyListener(luajava.createProxy("android.content.DialogInterface$OnKeyListener", {
          onKey = function(d, keyCode, event)
            if keyCode == 4 then
              service.speak("اضغط على موافق للتنفيذْ، أو على إعادة المحاولة لإدخال المفتاح مجددًا")
              return true
            end
            return false
          end
        }))
        successDialog.setPositiveButton("موافق", function() os.exit(0) end)
        successDialog.setNegativeButton("إعادة المحاولة", function() updateApiKey() end)
        successDialog.show()
       else
        LuaDialog()
        .setTitle("خطأ في الكتابة")
        .setMessage("تعذر فتح الملف للكتابة.")
        .setPositiveButton("موافق", function() end)
        .show()
      end
     else
      LuaDialog()
      .setTitle("تنبيه")
      .setMessage("الرجاء إدخال مفتاح جديد")
      .setPositiveButton("إعادة المحاولة", function() updateApiKey() end)
      .show()
    end
  end)

  dlg.setNegativeButton("إلغاء", function() dlg.dismiss() end)
  dlg.setButton3("الحصول على مفتاح جديد", function()
  local url = "https://aistudio.google.com/apikey" local intent = Intent(Intent.ACTION_VIEW) intent.setData(Uri.parse(url)) this.startActivity(intent)end)
  dlg.show()
end


local geminiApiKey = getGeminiApiKey()
local geminiApiEndpoint = "https://generativelanguage.googleapis.com/v1beta/models/gemini-2.0-flash:generateContent"

local handler = Handler(Looper.getMainLooper())
aiResponseReceived = true  -- متغير عام لمراقبة حالة التحدث

function calcAr()
    local luajava = require("luajava")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local activity = this
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local vibrator = activity.getSystemService("vibrator")

    aiResponseReceived = false  -- إعادة التهيئة هنا عند بدء الاستماع

    local function urlEncode(text)
        text = tostring(text)
        text = text:gsub("\n", "\r\n")
        text = text:gsub("([^%w %-%_%.%~])", function(c)
            return string.format("%%%02X", string.byte(c))
        end)
        text = text:gsub(" ", "+")
        return text
    end

    local function startVoiceRecognition(activity)
        local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

        handler.postDelayed(function()
            vibrator.vibrate(50)
        end, 350)

        local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
            onReadyForSpeech = function(params) end,

            onResults = function(params)
                local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
                local text = results.get(0)

                handler.postDelayed(function()
                    vibrator.vibrate(100)
                end, 350)

                if text and text ~= "" then
                    text = text:gsub("جمع", "+")
                    text = text:gsub("زائد", "+")
                    text = text:gsub("طرح", "-")
                    text = text:gsub("ناقص", "-")
                    text = text:gsub("ضرب", "*")
                    text = text:gsub("في", "*")
                    text = text:gsub("قسمة", "/")
                    text = text:gsub("تقسيم", "/")
                    text = text:gsub("نقسمها على", "÷")

                    local inputText = "أرجوك إجراء العملية الحسابية وإعطاء النتائج دون إضافة أي عبارات زائدة أو أي جواب آخر، فقط قم بإعطائي النتيجة التي يتم حسابها. Return only the calculated result: " .. text

                    local requestBody = cjson.encode({
                        contents = {
                            {
                                parts = {
                                    { text = inputText }
                                }
                            }
                        }
                    })

                    local headers = {
                        ["Content-Type"] = "application/json",
                        ["x-goog-api-key"] = geminiApiKey
                    }

                    Http.post(geminiApiEndpoint, requestBody, headers, function(status, data)
                        local node = service.getEditText()

                        if status == 200 then
                            local response = cjson.decode(data)
                            if response and response.candidates and response.candidates[1] and
                               response.candidates[1].content and response.candidates[1].content.parts and
                               response.candidates[1].content.parts[1] and
                               response.candidates[1].content.parts[1].text then

                                local cleanedData = response.candidates[1].content.parts[1].text
                                this.speak(cleanedData)
                            else
                                this.postSpeak(500, "تنسيق استجابة Gemini 2.0 Flash غير متوقع.")
                                service.insertText(node, text .. " \n")
                                print("Gemini API Response Data:", data)
                            end
                        else
                            this.postSpeak(500, "حدث خطأ في الاتصال بـ Gemini 2.0 Flash API: " .. status)
                            service.insertText(node, text .. " \n")
                            print("Gemini API Error Status:", status)
                            print("Gemini API Error Data:", data)
                        end

                        aiResponseReceived = true
                    end)
                else
                    aiResponseReceived = true  -- حتى يتم استدعاء calcAr مرة أخرى
                end
            end,

            onError = function(error)
                this.postSpeak(200, "لم يتم التقاط أي نص.")
                aiResponseReceived = true  -- حتى يتم إعادة المحاولة
            end
        })

        recognizer.setRecognitionListener(recognitionListener)
        recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
end
service.postSpeak(100, "يرجى إملاء العملية الحسابية.")
local function checkSpeakingStatus()
    if not service.isSpeaking() and aiResponseReceived then
        calcAr()
    else
        handler.postDelayed(checkSpeakingStatus, 1000)
    end
end

handler.postDelayed(checkSpeakingStatus, 500)