local dlgTitle = LuaDialog()
local editTitle = loadlayout({EditText})
editTitle.setBackgroundColor(0xFF00008B)
editTitle.setHint("أدخل عنوان الملف")
editTitle.setContentDescription("أدخل عنوان الملف.")

dlgTitle.setTitle("عنوان الملف")
dlgTitle.setView(editTitle)

local handler = Handler(Looper.getMainLooper())
local function checkSpeakingStatus()
  if not service.isSpeaking() then
    dictAr()
  else
    handler.postDelayed(checkSpeakingStatus, 1000)
  end
end
handler.postDelayed(checkSpeakingStatus, 1500)

dlgTitle.setButton("إدخال المحتوى", function()
  local fileTitle = tostring(editTitle.getText()):gsub("[\\/:*?\"<>|]", "_"):match("^%s*(.-)%s*$")
  if fileTitle == "" then
    service.postSpeak(500, "الرجاء إدخال العنوان أولاً.")
    return
  end

  local dlgContent = LuaDialog()
  local editContent = loadlayout({EditText})
  editContent.setLines(6)
  editContent.setHint("أدخل محتوى الملف")
  editContent.setContentDescription("أدخل محتوى الملف.")
  editContent.setBackgroundColor(0xFF8B4513)

  dlgContent.setTitle("محتوى الملف: " .. fileTitle)
  dlgContent.setView(editContent)

local handler = Handler(Looper.getMainLooper())
local function checkSpeakingStatus()
  if not service.isSpeaking() then
    dictAr()
  else
    handler.postDelayed(checkSpeakingStatus, 1000)
  end
end
handler.postDelayed(checkSpeakingStatus, 1500)
  dlgContent.setButton("حفظ", function()
    local fileText = tostring(editContent.getText()):match("^%s*(.-)%s*$")
    if fileText == "" then
      service.postSpeak(500, "الرجاء إدخال المحتوى أولاً.")
      return
    end

    local folderPath = "/storage/emulated/0/Documents/الإملاء المريح/"
    io.mkdir(folderPath)
    local extension = ".txt"

    local counter = 1
    local fileName = fileTitle .. extension
    local filePath = folderPath .. fileName
    while io.open(filePath, "r") do
      fileName = fileTitle .. "_" .. counter .. extension
      filePath = folderPath .. fileName
      counter = counter + 1
    end

    local file = io.open(filePath, "w+")
    if file then
      file:write(fileText)
      file:close()
      service.postSpeak(500, "تم حفظُ ملف: " .. fileName .. " في Documents/الإملاء المريح")
    else
      service.postSpeak(500, "فشل في حفظ الملف.")
    end
  end)

  dlgContent.setNegativeButton("إلغاء", function() dlgContent.dismiss() end)
  dlgContent.show()
end)

dlgTitle.setNegativeButton("إلغاء", function() dlgTitle.dismiss() end)
dlgTitle.show()