require "import"
task(500,function()
utf8 = require("utf8")

function remove_punctuation_and_normalize_spaces(text)
    -- تعريف نمط لجميع علامات الترقيم الإنجليزية والعربية
    local punctuation_pattern = "[%p٪٪،؛؟!؟ـ-]"
    -- استبدال علامات الترقيم بمسافات
    local result = utf8.gsub(text, punctuation_pattern, " ")
    -- إزالة المسافات الزائدة والإبقاء على مسافة واحدة، مع الحفاظ على الأسطر الجديدة
    result = utf8.gsub(result, "[%s]+", function(space)
        if space:find("\n") then
            return "\n"
        else
            return " "
        end
    end)
    -- إزالة المسافات في البداية والنهاية لكل سطر إن وجدت
    result = utf8.gsub(result, "[ \t]+$", "")
    result = utf8.gsub(result, "^[ \t]+", "")
    return result
end

local original_text = service.getText(node)
local clean_text = remove_punctuation_and_normalize_spaces(original_text)
service.setText(clean_text .."\n") -- النتيجة: "مرحبًا كيف حالك\nهذا مثال"
end)